unit ForevalD_Lib;
{******************************************************************************}
{                                                                              }
{                 SOREL (C)CopyRight 1999-2003. Russia, S.-Petersburg.         }
{                                                                              }
{                                                                              }
{                          interface of ForevalD                               }
{                                                                              }
{                                                                              }
{                                  ver. 1.0.0.104                              }
{******************************************************************************}

//Note:
{
rus:
       Delphi:
Delphi 2009: tools/options/debugger options/language exceptions/(notify on language exception - off)  (EConvertError - on)


}

{
eng:
Before compilation it is necessary to prohibit all exceptions of Delphi:
Delphi 2009: tools/options/debugger options/language exceptions/(notify on language exception - off) or (EConvertError - on)
}




interface

uses
ForevalD_Main, ForevalD_DiffNumeric, SysUtils;

const
fd_DISABLE              = 0;
fd_ENABLE               = 1;
fd_SHOW_EXCEPTION       = 22;
fd_SYNTAX_EXTENSION     = 38;
fd_VAR_NAME_SHIFT       = 30;
fd_FUNC_NAME_SHIFT      = 31;




fd_UNKNOWN_SYMBOL             = 208;
fd_MISSING_LEFT_BRACKET       = 209;
fd_MISSING_RIGHT_BRACKET      = 210;
fd_MISSING_OPERATION          = 211;
fd_WRONG_NUMBER_ARGUMENTS     = 212;
fd_MISSING_EXPRESSION         = 213;
fd_UNKNOWN_FUNCTION           = 214;
fd_ERROR_AT_ADDITION_FUNCTION = 215;
fd_NONEXISTENT_FUNCTION       = 216;
fd_INCORRECT_ARGUMENT         = 217;
fd_MISSING_ARGUMENT           = 218;


fd_ACCESS_VIOLATION           = 200;
fd_OUT_OF_MEMORY              = 201;
fd_STACK_OVERFLOW             = 202;
fd_ZERO_DIVIDE                = 203;
fd_INVALID_OPERATION          = 204;
fd_OVERFLOW                   = 205;
fd_UNDERFLOW                  = 206;
fd_INT_OVERFLOW               = 207;









type TForevalD_Custom = class(TForevalD)





        procedure fdDiffExpr(Expr: String; N: Integer; var SDiff: String);                                     stdcall;
        procedure fdSetDiffVar(NameDV: String);                                                                stdcall;
        procedure fdAddNewNameFunction(Name,NewName: String);                                                  stdcall;
        procedure fdSet(mode: Cardinal; value: Cardinal);                                                      stdcall;
        procedure fdGetSyntaxErrorCode(var CError: Cardinal);                                                  stdcall;
        procedure fdGetSyntaxErrorString(var SError:String);                                                   stdcall;
        //numeric:
        function fdDiff1(Func,PV: TAddress;  VType: Integer): TFloatType;                                      stdcall;
        function fdDiff2(Func,PV: TAddress;  VType: Integer): TFloatType;                                      stdcall;
        function fdDiff3(Func,PV: TAddress;  VType: Integer): TFloatType;                                      stdcall;
        function fdDiff4(Func,PV: TAddress;  VType: Integer): TFloatType;                                      stdcall;
        function fdDiffN(Func,PV: TAddress;  VType: Integer; N: Integer): TFloatType;                          stdcall;
        procedure fdCreateDiff;                                                                                stdcall;

end;



var

 //ForevD: TForevalD_Custom;
 E_Code: Cardinal;


implementation





procedure _DeleteSpace(S: String; var S1: String);
var i: Integer;
begin
i:=Length(S);

 while i >= 1 do
 begin
    if S[i] = ' ' then
   begin
    Delete(S,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S,1,Length(S));
end;




procedure TForevalD_Custom.fdSetDiffVar(NameDV: String);
begin
  inherited SetDiffVar(NameDV);
end;



procedure TForevalD_Custom.fdDiffExpr(Expr: String; N: Integer; var SDiff: String);
var
NS: Cardinal;
S,SD: String;
i: integer;
begin

S:=Expr;

_DeleteSpace(S,S);

for I := 0 to N-1 do
begin
   {ForevD.}inherited SetExtExpression(S);
   if {ForevD.}inherited SyntaxError = 0 then
   begin
    S:={ForevD.}inherited DiffString;
   end;
end;


SDiff:=S;
end;




procedure TForevalD_Custom.fdAddNewNameFunction(Name,NewName: String);
begin
  inherited AddNewNameFunction(Name,NewName);
end;


procedure TForevalD_Custom.fdSet(mode: Cardinal; value: Cardinal);
begin
if mode = fd_ENABLE then
  begin
   if value = fd_SHOW_EXCEPTION      then  inherited ShowException:=True else
   if value = fd_VAR_NAME_SHIFT      then inherited VarShift:=True          else
   if value = fd_FUNC_NAME_SHIFT     then inherited FuncShift:=True       else
   if value = fd_SYNTAX_EXTENSION    then inherited SyntaxExtension:=True    ;
  end
 else
if mode = fd_DISABLE then
  begin
    if value = fd_SHOW_EXCEPTION     then  inherited ShowException:=False else
    if value = fd_VAR_NAME_SHIFT     then  inherited VarShift:=False       else
    if value = fd_FUNC_NAME_SHIFT    then  inherited FuncShift:=False       else
    if value = fd_SYNTAX_EXTENSION    then inherited SyntaxExtension:=False    ;
  end
end;




procedure TForevalD_Custom.fdGetSyntaxErrorCode(var CError: Cardinal);
begin
 CError:=0;
 if inherited SyntaxError <> 0 then
 begin
  case inherited SyntaxError of
   1:         CError:=fd_UNKNOWN_SYMBOL;
   2:         CError:=fd_MISSING_LEFT_BRACKET;
  10:         CError:=fd_MISSING_RIGHT_BRACKET;
   3:         CError:=fd_MISSING_OPERATION;
   4:         CError:=fd_WRONG_NUMBER_ARGUMENTS;
   5:         CError:=fd_MISSING_EXPRESSION;
   6:         CError:=fd_UNKNOWN_FUNCTION;
   else       CError:=inherited SyntaxError;
  end;
 end
else
if inherited InternalError <> 0 then
begin
  case inherited  InternalError of
   6: CError:=fd_ACCESS_VIOLATION;
   7: CError:=fd_OUT_OF_MEMORY;
   8: CError:=fd_STACK_OVERFLOW;
   1: CError:=fd_ZERO_DIVIDE;
   2: CError:=fd_INVALID_OPERATION;
   3: CError:=fd_OVERFLOW;
   4: CError:=fd_UNDERFLOW;
   5: CError:=fd_INT_OVERFLOW;
  end;
end;

end;







procedure TForevalD_Custom.fdGetSyntaxErrorString(var SError:String);
begin
  SError:=inherited  SyntaxErrorString;
end;


{
procedure TForevalD_Custom.fdRenameFunction(Name,NewName: String);
begin
  inherited  RenameFunction(Name,NewName);
end;
}

function TForevalD_Custom.fdDiff1(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  fdDiff1:=Derivative1(Func,PV,VType);
end;

function TForevalD_Custom.fdDiff2(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  fdDiff2:=Derivative2(Func,PV,VType);
end;

function TForevalD_Custom.fdDiff3(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  fdDiff3:=Derivative3(Func,PV,VType);
end;

function TForevalD_Custom.fdDiff4(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  fdDiff4:=Derivative4(Func,PV,VType);
end;
{
function fdDiff5(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  fdDiff5:=Derivative5(Func,PV,VType);
end; }

function TForevalD_Custom.fdDiffN(Func,PV: TAddress;  VType: Integer; N: Integer): TFloatType; stdcall;
begin
  fdDiffN:=DerivativeN(Func,PV,VType,N);
end;

procedure TForevalD_Custom.fdCreateDiff; stdcall;
begin
  CreateDiff;
end;


initialization
begin


 {ForevD:=TForevalD_Custom.Create;
 ForevD.ShowException:=False;
 ForevD.VarShift:=False;
 ForevD.FuncShift:=False;
 CreateDiff;
 ForevD.DiffVar:='x'; }

end;



finalization
begin

//ForevD.Destroy;

end;

end.
