unit ForevalD_Main;

{******************************************************************************}
{                                                                              }
{                 SOREL (C)CopyRight 1999-2003. Russia, S.-Petersburg.         }
{                                                                              }
{                         Symbolical differentiation                           }
{                          of base functions(Foreval)                          }
{                                   ver. 1.0.0.110                             }
{******************************************************************************}




interface

uses
  Windows,  SysUtils, Math;

  const _PI:extended = 3.1415926535897932384626433832795;
  const  PI_2: extended = 3.1415926535897932384626433832795/2;
  const  _LDSF = 3;
  const  _LDSC = 4;
  const  _FUNC = 1;
  const  _COP  = 2;
  const  _JMP  = 5; //String Name: #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE
  const  _FLD  = 6; //FLD1,FLDZ
  //const  _LDSV = 5;

  const _Single = 1;
  const _Double = 2;
  const _Extended = 3;
  const _Pointer = 5;
  const _Integer = 4;

  const _None = 0;
  const _Const = 1;
  const _Var = 2;
  const _FVar = 3;
  const  Sh_D = 8;
  const  Sh_E = 16;

  const S_IM_UNIT: String = 'i'; //i,I - imaginary unit
  const S_CON: String = '_'; //z_ =(x,-y)


  const _STACK_ADR = 1;
  const _STACK_VAL = 2;
  const _ESP = 4;
  const _EAX = 5;
  const _STACK_INFINITE   = 6;
  const _STACK_INFINITE_A = 7;
  const _COMPILED = 9;

  const  T_Complex = 2;
  const  T_Real  = 1;
  const  T_Array = 3;
  const  T_Integer = 4;
  const  T_None = 5;
  const  _RE = 1;
  const  _IM = 2;
  const _RIGHT = 1;
  const _BACK = 2;
  const _INFINITE = -1;

  const S_10:extended = 10;
  const S_2:extended = 2;


  const  _MEM = 20;
  const  _FPU = 21;
const
  IM_UNIT =        10;
  D_Real =         11;
  E_Real =         12;
  D_Complex =      13;
  E_Complex =      14;
  D_Any  =         15;
  E_Any =          16;
  D_Array_Real =  17;
  E_Array_Real  = 18;




  //   Alg.ExtFunc[N]
  const  C_ADD = 0;
  const  C_SUB = 1;
  const  C_MUL = 2;
  const  C_DIV = 3;
  const  C_POWER = 4;
  const  C_RE = 8;
  const  C_IM = 9;
  const  C_SQR  = 29;
  const  C_SQRT = 30;
  const  C_FACT = 31;
  const  C_PWR3 = 35;
  const  C_PWR4  = 36;
  const  C_PWRN1 = 37;
  const  C_PWRN2 = 38;
  const  C_PWRN3 = 39;
  const  C_PWRN4 = 40;
  const  C_TRUNC = 35;
  const  C_FRAC  = 36;
  const  C_IPWRSGN = 52;
  const  C_LDSVX  = 53;
  const  C_IF     = 40;
  const  C_IFNOP  = 41;



type TExternalException = procedure; //  



type TVar = record
              adr: Cardinal;
              TV:  Integer;   //D_Real, E_Real, D_Complex, E_Complex, IM_UNIT
            end;

type
TAddress = Cardinal;

type TFloat = extended; {extended} // 

type PFloat = ^TFloat;

type
TComplexD =  record
               x: double;
               y: double;
              end;


type
TComplexE =  record
               x: extended;
               y: extended;
              end;



type
TStack = array of TComplexE;


type
TArray4 = array [1..4] of byte;
type TCode = array of Byte;




type TArrayI = array of Integer;
type TArrayC = array of Cardinal;
type PArrayI = ^TArrayI;
type TArrayD = array of Double;
type TArrayE = array of extended;

type TIntType = array of Cardinal;



type TIntFunc  = //array of
                  record
                   TypeF:   Cardinal;          //  -  T_Real,T_Complex
                   CallT:   Cardinal;          // (_ESP,_EAX,_STACK,_STACK_INFINITE,_STACK_INFINITE_A)
                   CLST:    Cardinal;          // 
                   Arrow:   Cardinal;          //   _RIGHT,_BACK
                   Addr:    Cardinal;             // -
                   SDeep:   Integer;
                   IntF:    Integer;           //=1( -); =0()
                   N:    Integer;              // . N=-1,-2 Infinite (-1:   (_STACK_INFINITE);-2(_STACK_INFINITE_A):     )
                   TV:   array of Cardinal;    //      (T_Real,T_Complex)  (Size=N)
                   TM:   array of Cardinal;    //      (_Double,_Extended)   (Size=N)
                   ArgAdr:  TArrayI;           //   - fl_PRECOMPILED
                  end;

type TIntFuncA = array of TIntFunc;

type TAlgFunction = array of
                      record
                       Name:  String;          // -
                       NameF: array of string; //  ForevalD:   
                       Func: TIntFuncA;        // -   
                      end;






type TAlgOperation = array of
                      record
                       PR:  Cardinal;     //   ( '0'!)            Operation priority (except ' 0 '!)
                       Name:  String;     //  
                       NFunc: Cardinal;   //   -
                       GS:  Integer;     // . :  ((-1);(-2))  . : >= 0!  For one-argument operations: place ((-1) before; (-2) behind) for many-argument operations:> = 0!!!
                       SE:  Integer;     //F_SyntaxExtension(=1)
                      end;


                      //  .    .  !!!
                      //Priority any one-argument operations above any many-argument operations



type TAlgObject = array of
                   record
                    Name: String;
                   TypeF: Cardinal;          //   (T_Real,T_Complex,T_Array,T_Integer)
                    Addr: Cardinal;
                   MType: Cardinal;         //_Double,_Extended
                   end;

type TAlgLoadFunction = array of
                        record
                         TypeF: Cardinal;    //   
                          Addr: Cardinal;
                          Name: String;     // 
                         end;




type
 PFunc      = ^TFunc;



 
 TFunc = record
               NL: Cardinal;               //    
               NM: Cardinal;
               S:  Cardinal;               //Stack
               N:  Cardinal;               //Node
           TypeF:  Cardinal;               // 
           TypeA:  Cardinal;               //  (-   . )
             COP:  Cardinal;
           NFunc:  Cardinal;               //  -
              NF:  Cardinal;               // -  
            NObj:  Cardinal;               //  
              FD:    TFloat;               //
              FI:  Integer;
             Arg:  Cardinal;               //  ( infinite)
             IdN:    Cardinal;
             IdL:    Cardinal;
        ArgTypes:  TArrayI;                 //     TIntFunc.N=-2(_STACK_INFINITE_A)
           SData:  Integer;                 //   /FPU    DinamicLoad
           RData:  TArrayI;                 //    /FPU    DinamicLoad
          SData1:  Integer;                 //   /FPU    
           MEM:    Cardinal;
             NC:   Cardinal;   //  ICOMP[NC]  
             CS:   Cardinal; //      +     
             NV1:    Integer;//TVar;
             NV2:    Integer;//TVar;
             AI:     Integer; //control
             TS:   Integer;  //_RE,IM,0
             Inv:  Integer;               //-    . -
          ExtArg:  Integer;              //=1,0 -      - .  (  - 0) -  
         end;


type
TArrayOfPFunc = array of PFunc;

type
TArrayOfTFunc = array of TFunc;




type TNStack = record
                S: Cardinal; //  
                N: Cardinal; //  
              end;


type
PNode = ^TNode;
TNode = record
         Stack: TNStack;
         IdN:    Cardinal;
         IdL:    Cardinal;
         NL:     Cardinal;           //   ( );
         NCOP:   Cardinal;           // ( ) ( );
         NFunc:  Cardinal;           //- (  -)
         NObj:   Cardinal;           //  
         COP:    Integer;            //COP: = 1(-)  Func   -;
                                     //2()  NCOP  ;
                                     //3( )  NObj -  ;
                                     //4( )  FD - ;
         FD:     TFloat;             //
         Expression: String;
         SDiff:  String;
         SFunc:  String;
         TypeF: Integer;             //-    . -
         Inv: Integer;               //-    . -
         NV1:    Integer;//TVar;
         NV2:    Integer;//TVar;
         AI:     Integer; //control
         TS: Integer;    //_RE,_IM,0
         cif:    Integer;
         tif:    Integer;
         SData:  Integer;
         RData: TArrayI;
         NM: Cardinal;
         NF: Cardinal;
         Ch: PNode;
         Nb: PNode;
         Pr: PNode;
       end;

type
TDataNode = record
             N:      Cardinal;
             IdN:    Cardinal;
             NCOP:   Cardinal;
             NFunc:  Cardinal;
             NObj:   Cardinal;
             COP:    Integer;
             FD:     TFloat;
             FX:     Extended;
             NV1:    Integer;//TVar;
             NV2:    Integer;//TVar;
             AI:     Integer; //control
             TS:     Integer;    //_RE,_IM,0
             NF:     Cardinal;
             cif:    Integer;
             tif:    Integer;
             Expression: String;
             TypeF: Integer;             //-    . -
             Inv:   Integer;             //-    . - (=1: sub->subr; div->divr)
             SDiff:  String;
             SFunc:  String;
            end;

type
TLevel = record
          NL:  Cardinal;               //   ( );
          IdL: Cardinal;
          Expression: String;
          //ExtArg: Integer;
        end;

type PLevel = array of TLevel;




type
TArrayS = array of String;





type
TParamList = record
               Name: String;
               Value: TFloat;
             end;






{type
TArrayI = array of Integer;
}

type
TString1 = String[1];





type
TAlgebra = record
             Name:  String;
            Types:  TArrayC;
              Obj:  TAlgObject;
              Opr:  TAlgOperation;
           ExFunc:  TAlgFunction;
           //LdFunc:  TAlgLoadFunction;
          //Bracket:  TAlgBracket;
           end;


//type TExternalException = procedure (TypeError: Integer); {of object;} stdcall;


type

  TForevalD = class



  private


    Alg: TAlgebra;
    CurrentExpression: String;      // 
    LFunc    : Cardinal;          //  
    StackSize: Cardinal;          // 
    ArgM : TArrayS;              //    > 2 .(  '0')
    Tree: PNode;                                //  
    //F_SyntaxExtension:       Boolean; //./.:  - > 1; '{' ; '['; '!'; '^'; .
    BeginTree: PNode;                 //   ( )
    F_VarShift:              Boolean;  // var&param  // .
    F_FuncShift:             Boolean;
    F_SyntaxErrorCode: Cardinal;    //   
    F_SyntaxExtension : Boolean;    //|Expr|->abs(expr); [expr]->trunc(expr); {expr}->frac(expr)
    F_SyntaxErrorString: String;   // 
    F_CalcErrorCode: Integer;    //. 
    F_InternalError: Integer;
    F_ShowException: Boolean;      //./.  
    F_ExternalException: Boolean;  //./.   
    F_CalcType: Integer;          //   = T_Real; T_Complex(=   )
    //BeginLinker: Integer; //0,1 - /  - -   
    F_BeginCalc: Integer; //0,1 - /  - -   
    //F_MaxLenArg: Cardinal; //.        
    F_ExtFunc: Boolean;  // -  
    F_ComplexNumber: Boolean;
    S_DiffString, S_DiffVar: String;
    N_DiffVar: Integer;

    F_DataType: Integer; //_Double,_Extended;
    NAdr: Cardinal;
    //F_SaveStack: Boolean;
    //Alg:
    F_NumberStack: Cardinal;
    F_Address: Cardinal;
    F_NumberArg: Cardinal;
    F_FConst: TFloat;
    ICOMP: TCode;
    F_SyntaxErrorString1: String;
    F_IdN: Cardinal;
    F_ResultType: Cardinal;
    F_ArgTypes: Cardinal;    //              (TIntFunc.N=-2(_STACK_INFINITE_A))
    //F_ExtNumberArg: Cardinal;
    NFunc: Cardinal;
    SAdr: array of Cardinal;
    N_Stack:Integer;
    SMAX:Integer;
     _MaxStack:Integer;
     F_StackDeep: Integer;
     F_EnableCheckStack: Boolean;
     E_OverFlow: Boolean;
     //Db_DinLoadOverFlow: Boolean;
     Db_XchBrSDeep: Integer;     //    TreeOpimization (: _Enable,_Auto)
     Db_XchBrNXch: Integer;      //   TreeOpimization
     Db_DinLoadSDeep: Integer;   //    DinamicLoad  (: _Enable,_Auto)
     Db_DinLoadNMem: Integer;    //   DinamicLoad
     Db_DinLoadOverFlow: Boolean;//True,     DinamicLoad    
     Db_CmplMaxStack: Integer;   //   

     F_SaveInFPU: Boolean;
     F_DinamicLoadOptimization: Boolean;
     F_OperationOptimizator: Boolean;
     F_Opt: Boolean;
     REG,REGA:  array [1..8] of Integer;
     LInternalFunc: Integer;
     F_JMP: Integer;
     F_SData: Integer;
     n_dv: integer;
     F_ExtFuncD: Boolean; //  -  - ( )

    function  FindNumberPR(PR: Cardinal): Cardinal;
    function  FindOperation(S: String): Cardinal;
    procedure FindSingleOP(S: String; var NCop: Integer);

    //procedure FindLdFunction(var nf: Integer);
    //procedure FindConstLdFunction(var nf: Integer);



    procedure FindExternalBracket(S: String; var SS: String);
    procedure FindExternalBracketN(S: String; var SS: String; var Neg: Integer);
    procedure IsNum(S2: String; var fx: extended; var bnum: boolean);

    procedure FindMainOperation(S:String; var NCOP: Integer; var NPos: Cardinal);
    procedure StringAnalizator(S:String; var ND: TDataNode; var HS:PLevel);
    procedure WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
    procedure SubstParam(S1: String;  var C: TFloat; var SB: Integer);
    function  PointToDec(S: String):String;
    procedure CreateInitData;
    procedure FindVar(S1: String; var ni: Integer);
    procedure SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
    procedure IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
    procedure NumberAnalizator(S: String; var ND: TDataNode;  var EOFN: Boolean);
    procedure NumberAnalizatorA(S: String;  var nf: Integer; var FD: extended; var EF: Integer);
    procedure WriteNodeParam(ND: TDataNode);
    procedure InitNode(var ND: TDataNode);
    procedure FindFunction(S: String;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
    procedure FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
    procedure PrevTreat(S: String; var S1: String);
    procedure ReplaceAbsBr(S: String; var S1: String);
    procedure ReplaceTruncBr(S: String; var S1: String);
    procedure ReplaceFracBr(S: String; var S1: String);
     procedure FreeTree;
    //procedure FreeFunction;
    procedure Linker(S:String);

     procedure FindManyArg(S: String; var ArgM: TArrayS);
    procedure CreateFuncList;


    procedure InitConstDb;
    procedure GetVar(N: Integer; var Adr: Cardinal; var TV: Integer; var TM: Integer);
    procedure FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
    procedure FindJMP(S: String; var ni: Integer);
    procedure FindFLD(S: String; var ni: Integer);
    procedure SetDiff1;
    function  FindDiffVar(ni: Integer): Boolean;


  protected

   procedure  CalcException;  virtual;


  public

   ExtException: {Pointer}TExternalException;  //  

   constructor Create;
   destructor  Destroy;
   //procedure InitFuncStruct(var FS: TIntFunc);
   procedure SetExtExpression(S: String);
   //procedure FreeExtFunc(E_Func: TFunction);
   property  VarShift: Boolean read F_VarShift write F_VarShift default False;
   property  FuncShift: Boolean read F_FuncShift write F_FuncShift default False;
   property  ShowException: Boolean read F_ShowException write F_ShowException default True;
   property  SyntaxError: Cardinal read  F_SyntaxErrorCode write F_SyntaxErrorCode default 0;
   property  SyntaxErrorString: String read F_SyntaxErrorString write F_SyntaxErrorString;
   property  CalcError: Integer read F_CalcErrorCode write F_CalcErrorCode default 0;
   property  InternalError: Integer read F_InternalError write F_InternalError default 0;
   property  SyntaxExtension: Boolean read F_SyntaxExtension write F_SyntaxExtension default True;
   property  ExternalException: Boolean read F_ExternalException write F_ExternalException default False;
   property  BeginCalc: Integer read F_BeginCalc write F_BeginCalc default 0;
   procedure RenameFunction(Name,NewName: String);
   procedure SetType(IdType: Cardinal);
   procedure SetObject(Name: String; Addr: Cardinal; IdType: Cardinal; MType: Cardinal);
   procedure SetFunction(Name: String);
   procedure AddNewNameFunction(Name,NewName: String);
   //procedure SetLoadFunction(IdType: Cardinal; Addr: Cardinal; Name: String);
   procedure SetOperation(Name: String; Func: String; PR: Cardinal; GS: Integer; SE: Integer);
   procedure FreeVar;
   procedure FindFunc(Name: String; TV: array of Cardinal; var idn,idf,CallT: integer; var adr: Cardinal);
   procedure DeleteFunc(idn,idf: integer);
   property  ExtFuncD: Boolean read F_ExtFuncD write  F_ExtFuncD default False;
   property  DiffString: String read S_DiffString write  S_DiffString;
   property  DiffVar: String read S_DiffVar write  S_DiffVar;
   procedure SetDiffVar(NameDV: String);





  published



  end;



var



  ForevalD: TForevalD;



implementation
var
MEM: Cardinal;
zi: TComplexD;
NameTypeS: array [1..4] of String;
G_FMT: TFormatSettings;
//V1: TArrayD;    //test








procedure TForevalD.SetType(IdType: Cardinal{; Name: String});
label endp;
var
i: Integer;
begin
{
for i:=0 to High(Alg.Types) do
begin
 if Alg.Types[i] = IdType then goto endp;
end;
}
SetLength(Alg.Types,Length(Alg.Types)+1);
Alg.Types[High(Alg.Types)]:=IdType;

endp:
end;



procedure TForevalD.SetObject(Name: String; Addr: Cardinal; IdType: Cardinal; MType: Cardinal);
label endp;
var
i: integer;
begin
 for i := 0 to Length(Alg.Obj) - 1 do
   begin
     if (Alg.Obj[i].Name  = Name) and (Alg.Obj[i].TypeF = IdType) and (Alg.Obj[i].MType = MType) then
     begin
       Alg.Obj[i].Addr:=Addr;
       goto endp;
     end;
   end;
 SetLength(Alg.Obj,Length(Alg.Obj)+1);
 Alg.Obj[High(Alg.Obj)].TypeF:=IdType;
 Alg.Obj[High(Alg.Obj)].MType:=MType;
 Alg.Obj[High(Alg.Obj)].Addr:=Addr;
 Alg.Obj[High(Alg.Obj)].Name:=Copy(Name,1,Length(Name));

 endp:
end;



procedure TForevalD.FreeVar;
begin                           // [0]   
  SetLength(Alg.Obj,0);
  SetObject(S_IM_UNIT,Cardinal(@zi),T_Complex,_Double);
end;





procedure TForevalD.SetFunction(Name: String);
label endp;
var
N,K,i,j,m,bf: Integer;
begin


  SetLength(Alg.ExFunc,Length(Alg.ExFunc)+1);
  Alg.ExFunc[High(Alg.ExFunc)].Name:=Copy(Name,1,Length(Name));

  K:=High(Alg.ExFunc);

  SetLength(Alg.ExFunc[K].NameF,1);
  Alg.ExFunc[K].NameF[0]:=Copy(Name,1,Length(Name));

endp:
end;




procedure TForevalD.AddNewNameFunction(Name,NewName: String);
var
 k: integer;
begin

for k:=0 to High(Alg.ExFunc) do
 begin
  if Name = Alg.ExFunc[k].Name then
  begin
    SetLength(Alg.ExFunc[k].NameF,Length(Alg.ExFunc[k].NameF)+1);
    Alg.ExFunc[k].NameF[High(Alg.ExFunc[k].NameF)]:=Copy(NewName,1,Length(NewName));
  end;
 end;

end;



procedure  TForevalD.SetDiffVar(NameDV: String);
begin
 S_DiffVar:=Copy(NameDV,1,Length(NameDV));
 //FindVar(NameDV,N_DiffVar);
end;



procedure TForevalD.FindFunc(Name: String; TV: array of Cardinal; var idn,idf,CallT: integer; var adr: Cardinal);
label endp;
var
i,j,N,K,m,bf: Integer;
begin
adr:=0; CallT:=0; idn:=-1; idf:=-1;
for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin
    K:=i;
    N:=High(Alg.ExFunc[K].Func);
    //    :
    for m := 0 to High(Alg.ExFunc[K].Func) do
    begin
     if Length(TV) = Length(Alg.ExFunc[K].Func[m].TV) then
     begin
       bf:=0;
       for j:=0 to High(TV) do
       begin
        if Alg.ExFunc[K].Func[m].TV[j] = TV[j] then inc(bf);
       end;
       if bf = Length(TV) then
       begin
         CallT:=Alg.ExFunc[K].Func[m].CallT;
         adr:=Alg.ExFunc[K].Func[m].Addr;
         idn:=K;
         idf:=m;
         goto endp;
       end;
     end;
    end;
   end;
  end;

endp:
end;




procedure TForevalD.DeleteFunc(idn,idf: integer);
begin
  Alg.ExFunc[idn].Func[idf].TV:=nil;
  Alg.ExFunc[idn].Func[idf].TM:=nil;
  Alg.ExFunc[idn].Func[idf].addr:=0;
  Alg.ExFunc[idn].Func[idf].N:=-1;
  Alg.ExFunc[idn].Func[idf].CallT:=0;
  Alg.ExFunc[idn].Func[idf].TypeF:=0;
  Alg.ExFunc[idn].Func[idf].IntF:=0;
end;


{
procedure TForevalD.SetLoadFunction(IdType: Cardinal; Addr: Cardinal; Name: String);
begin
 SetLength(Alg.LdFunc,Length(Alg.LdFunc)+1);
 Alg.LdFunc[High(Alg.LdFunc)].TypeF:=IdType;
 Alg.LdFunc[High(Alg.LdFunc)].Addr:=Addr;
 Alg.LdFunc[High(Alg.LdFunc)].Name:=Name;
end;
}


procedure TForevalD.SetOperation(Name: String; Func: String; PR: Cardinal; GS: Integer; SE: Integer);
label 1;
var
i,nf: Integer;                             //   1,2 -  -
begin                                      //PR - priority; GS - place ((-1) before; (-2) behind) ; SE - F_SyntaxExtension
nf:=-1;
for i:=0 to High(Alg.ExFunc) do
begin
 if Func = Alg.ExFunc[i].Name then
 begin
  nf:=i; goto 1;
 end;
end;

1:
if nf = -1 then begin {Error} end;
if PR <= 0 then begin {Error} end;

SetLength(Alg.Opr,Length(Alg.Opr)+1);
Alg.Opr[High(Alg.Opr)].Name:=Name{[1]};
Alg.Opr[High(Alg.Opr)].NFunc:=nf;
Alg.Opr[High(Alg.Opr)].PR:=PR;
Alg.Opr[High(Alg.Opr)].GS:=GS;
Alg.Opr[High(Alg.Opr)].SE:=SE;
end;







procedure TForevalD.Linker(S: String);
label endp;
var
HS: PLevel;
ND: TDataNode;
H,H1: PNode;
EOFN: Boolean;
i: Cardinal;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
New(Tree);
Tree^.Ch:=nil;
Tree^.Nb:=nil;
Tree^.Pr:=nil;
BeginTree:=Tree;
// :
Tree^.Expression:=Copy(S,1,Length(S));
Tree^.Stack.S:=1;
EOFN:=True;

SyntaxAnalizator(Copy(Tree^.Expression,1,Length(Tree^.Expression)),ND,HS,EOFN);
//:
//COP<>NOP:
while EOFN <> True do
begin
if F_SyntaxErrorCode <> 0 then goto endp;

New(H);
Tree^.Ch:=H;
inc(F_IdN);
WriteNodeParam(ND);
WriteLevelParam(H,HS,0);


H^.Stack.S:=Tree^.Stack.S;
H^.Pr:=Tree;
H1:=H;
H^.Ch:=nil;
H^.Nb:=nil;

for i:=1 to High(HS) do
begin
 New(H);
 H^.Ch:=nil;
 H^.Nb:=nil;
 WriteLevelParam(H,HS,i);
 H^.Stack.S:=H1^.Stack.S+1;
 H1.Nb:=H;
 H^.Pr:=Tree;
 //HS:=HS^.Next;
 H1:=H;
end;
Tree:=H^.Pr^.Ch;
HS:=nil; //??? (  )
SyntaxAnalizator(Copy(Tree^.Expression,1,Length(Tree^.Expression)),ND,HS,EOFN);
end;
//EOFN=True:    ( )
inc(F_IdN);
WriteNodeParam(ND);

//:
while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
 SyntaxAnalizator(Copy(Tree^.Expression,1,Length(Tree^.Expression)),ND,HS,EOFN);
//COP<>NOP:
while EOFN<>True do
 begin
 if F_SyntaxErrorCode <> 0 then goto endp;

 New(H);
 Tree^.Ch:=H;
 inc(F_IdN);
 WriteNodeParam(ND);
 WriteLevelParam(H,HS,0);

 H^.Stack.S:=Tree^.Stack.S;
 H^.Pr:=Tree;
 H1:=H;
 H^.Ch:=nil;
 H^.Nb:=nil;
 for i:=1 to High(HS) do
 begin
  New(H);
  H^.Ch:=nil;
  H^.Nb:=nil;
  WriteLevelParam(H,HS,i);

  H^.Stack.S:=H1^.Stack.S+1;
  H1.Nb:=H;
  H^.Pr:=Tree;
  H1:=H;
 end;
 Tree:=H^.Pr^.Ch;
 HS:=nil; //??? (  )
 SyntaxAnalizator(Copy(Tree^.Expression,1,Length(Tree^.Expression)),ND,HS,EOFN);
 end;
//EOFN=True:  
inc(F_IdN);
WriteNodeParam(ND);
end;
Tree:=Tree^.Pr;
end;

Tree:=BeginTree;

endp:
end;









procedure TForevalD.WriteNodeParam(ND: TDataNode);
begin
Tree^.Stack.N:=ND.N;
Tree^.NCOP:=ND.NCOP;
Tree^.FD:=ND.FD;
Tree^.NFunc:=ND.NFunc;
Tree^.COP:=ND.COP;
Tree^.NObj:=ND.NObj;
Tree^.IdN:=F_IdN;//ND.IdN;
Tree^.NV1:=ND.NV1;
Tree^.NV2:=ND.NV2;
Tree^.TypeF:=ND.TypeF;
Tree^.Inv:=ND.Inv;
Tree^.TS:=ND.TS;
Tree^.NF:=ND.NF;
Tree^.AI:=ND.AI;
Tree^.SDiff:=ND.SDiff;
Tree^.cif:=ND.cif;
Tree^.tif:=ND.tif;
Tree^.SFunc:=ND.SFunc;
end;



procedure TForevalD.WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
begin
H^.Expression:=Copy(HS[N].Expression,1,Length(HS[N].Expression));
H^.NL:=HS[N].NL;
H^.IdL:=F_IdN;//HS[N].IdL;
end;



procedure TForevalD.FindExternalBracket(S: String; var SS: String);
label 1,endp;
var
b,i,z,a:Integer;
begin
SS:=Copy(S,1,Length(S));



1:
if SS = '' then
begin
goto endp;
end;

if (SS[1] = '(') and (SS[Length(SS)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(SS)-1 do
  begin
   if SS[i] = '(' then b:=b-1;
   if SS[i] = ')' then b:=b+1;

   if b = 0 then goto endp;
  end;

 Delete(SS,Length(SS),1);
 Delete(SS,1,1);
 goto 1;
end;




endp:
end;





procedure TForevalD.FindExternalBracketN(S: String; var SS: String; var Neg: Integer);
label
2,3,endp;
var
b,i,z,a: Integer;
begin
SS:=Copy(S,1,Length(S)); z:=1;
2:
b:=0; a:=1;

if SS = '' then
begin
goto endp;
end;


if SS[1] = '-' then a:=2;
if  SS[a] = '(' then
begin
 b:=-1;
 for i:=a+1 to Length(SS)-1 do
 begin
  if SS[i] = '(' then b:=b-1;
  if SS[i] = ')' then b:=b+1;
  if b = 0 then goto 3
 end;


if SS[Length(SS)] = ')' then
begin
if a = 2 then
begin
Delete(SS,1,1);
z:=z*(-1);
end;
Delete(SS,1,1);
Delete(SS,Length(SS),1);
goto 2;
end;
end;
3:
if z = -1 then  Neg:=1
else  Neg:=0;


endp:
end;




procedure  TForevalD.IsNum(S2: String; var fx: extended; var bnum: boolean);
var
 S3: String;
 Neg: Integer;
begin
bnum:=false;
FindExternalBracketN(S2,S3,neg);
try
 fx:=StrToFloat(S3,G_FMT);
 bnum:=true;
 if neg = 1 then fx:=-fx
except
 bnum:=false;
end;

end;







function TForevalD.FindNumberPR(PR: Cardinal): Cardinal;
label 1;
var
i: Integer;
N: Cardinal;
begin
for i:=0 to High(Alg.Opr) do
begin
 if PR = Alg.Opr[i].PR then
 begin
  N:=i; goto 1;
 end;
end;

1:
FindNumberPR:=N;
end;



function TForevalD.FindOperation(S: String): Cardinal;
label 1;
var
i,NCOP: Integer;
begin
NCOP:=-1;
for i:=0 to High(Alg.Opr) do
begin
    if S = Alg.Opr[i].Name then
    begin
     NCOP:=i;
     goto 1;
    end;
end;

1:
if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) then NCOP:=-1;
FindOperation:=NCOP;
end;




procedure TForevalD.FindSingleOP(S: String; var NCop: Integer);
var
i,j,PR1,PR2: Integer;
NCop1,NCop2,ms,Ls,Lc: Integer;
BOP: Boolean;
Ss,Sc: String;
begin
BOP:=False;
PR1:=0;
PR2:=0;
NCop1:=-1; NCop2:=-1;  NCop:=-1;

Ss:=Copy(S,1,Length(S));
 if F_FuncShift = False then Ss:=LowerCase(Ss);
Ls:=Length(Ss);

for i:=0 to High(Alg.Opr) do
begin
 if Alg.Opr[i].GS < 0 then    // . 
 begin

    if Alg.Opr[i].GS = -2 then
    begin
     Lc:=Length(Alg.Opr[i].Name);
     Sc:=Copy(Ss,Ls-Lc+1,Lc);
     if Sc = Alg.Opr[i].Name then
     begin
      NCop2:=i;
     end;
    end
    else
    if Alg.Opr[i].GS = -1 then
    begin
     Lc:=Length(Alg.Opr[i].Name);
     Sc:=Copy(Ss,1,Lc);
     if Sc = Alg.Opr[i].Name then
     begin
      NCop1:=i;
     end;
    end;



    //for synt. error:
    if (S[Length(S)] = Alg.Opr[i].Name[1]) or (S[1] = Alg.Opr[i].Name[1]) then BOP:=True;
  end;  
end;



if (NCop1 <> -1) and (NCop2 <> -1) then
begin
 if  Alg.Opr[NCop1].PR < Alg.Opr[NCop2].PR then NCop:=NCop1 else NCop:=NCop2;
end
else
if NCop1 <> -1 then NCop:=NCop1
else
if NCop2 <> -1 then NCop:=NCop2;

//find synt. error
if (NCop = -1) and (BOP = True)  then
begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=S;
end;

if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) then NCOP:=-1;
end;




procedure TForevalD.FindMainOperation(S:String; var NCOP: Integer; var NPos: Cardinal);
label endp;
var
Pl,Ml: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1: Integer;
SE: Boolean;
begin
if S = '' then
begin
F_SyntaxErrorCode:=5;
goto endp;
end;

SE:=False;

NCOP1:=-1; NCOP2:=-1;  NCOP:=-1;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;

if S[1] = '(' then b:=-1 else
  if S[1] = '[' then b1:=-1 else
    if S[1] = '{' then b2:=-1 else
      if (S[1] = ')') or (S[1] = ']') or (S[1] = '}') then
      begin
       F_SyntaxErrorCode:=2;
       goto endp;
      end;


for i:=2 to Length(S)-1 {.. 1-    .. . }  do
begin
 if S[i] = '(' then b:=b-1;
 if S[i] = ')' then b:=b+1;
 if S[i] = '[' then b1:=b1-1;
 if S[i] = ']' then b1:=b1+1;
 if S[i] = '{' then b2:=b2-1;
 if S[i] = '}' then b2:=b2+1;

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin
  NCOP2:=FindOperation(S[i]);
  if Alg.Opr[NCOP2].GS >= 0 then // . 
  begin
   if (NCOP2 <> -1) and (NCOP1 <> -1) then
   begin
    { <=,     !!!}
    if (Alg.Opr[NCOP2].PR <= Alg.Opr[NCOP1].PR)  then
    begin
     NCOP1:=NCOP2;
     NPos1:=i;
    end;
   end
   else
   if (NCOP2 <> -1) and (NCOP1 = -1) then
   begin
    NCOP1:=NCOP2;
    NPos1:=i;
   end;
  end;
 end;

NPos:=NPos1;
NCOP:=NCOP1;
end;


//   . .  -x^y, -z1^z2   (neg)
//FindSingleOP(S,NCop,NPos1);
NCop1:=FindOperation(S[1]);
if (NCOP1 <> -1) and (Alg.Opr[NCOP1].PR < Alg.Opr[NCOP].PR)  then NCOP:=-1;


//find synt. error:
if NCop = -1 then
begin
 NCOP1:=FindOperation(S[1]); NCOP2:=FindOperation(S[Length(S)]);
 if NCOP1 <> -1 then
 begin
   if (Alg.Opr[NCOP1].GS >= 0) and (Alg.Opr[NCOP1].Name <> '-') then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=S;
   end
 end
 else
 if NCOP2 <> -1 then
 begin
   if Alg.Opr[NCOP2].GS >= 0 then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=S;
   end
 end;
end;

endp:
end;



procedure TForevalD.StringAnalizator(S:String; var ND: TDataNode; var HS:PLevel);
label endp;
var
SS,S1,S2: String;
PR,NPR: Cardinal;
BH,IH,IH1: PLevel;
i,p,b: Cardinal;
PR1,N,NCop: Integer;
ni: Integer;
NPos: Cardinal;
BOP: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
BOP:=0;

FindExternalBracket(S,SS);

InitNode(ND);
PR:=0;
FindMainOperation(SS,NCop,NPos);
N:=0;
if NCop <> -1 then
begin
 //inc(F_IdN);
 //ND.IdN:=F_IdN;
 SetLength(HS,2);
 HS[0].Expression:=Copy(SS,1,NPos-1);
 HS[0].NL:=1;
 //HS[0].IdL:=F_IdN;
 HS[1].Expression:=Copy(SS,NPos+1,Length(SS)-NPos+1);
 HS[1].NL:=2;
 //HS[1].IdL:=F_IdN;
 ND.N:=2;
 ND.COP:=_COP;
 ND.NFunc:=Alg.Opr[NCop].NFunc;
 ND.NCOP:=NCOP;  // 

 BOP:=2;
end
else
begin
 FindSingleOp(SS,NCop);
 if NCop <> -1 then
 begin
  ND.COP:=_FUNC;
  ND.N:=1;
  ND.NFunc:=Alg.Opr[NCop].NFunc;
  SetLength(HS,1);
  if Alg.Opr[NCop].GS = -1 then HS[0].Expression:=Copy(SS,2,Length(SS)-1)
  else
  if Alg.Opr[NCop].GS = -2 then HS[0].Expression:=Copy(SS,1,Length(SS)-Length(Alg.Opr[NCop].Name){-1});
  HS[0].NL:=1;
  ND.NCOP:=NCOP;  // 
  ND.SFunc:=Alg.ExFunc[Alg.Opr[NCop].NFunc].Name;    //forevald
  inc(F_IdN);
  //ND.IdN:=F_IdN;
  //HS[0].IdL:=F_IdN;
 end
 else
 begin
  ND.COP:=0;
  SetLength(HS,1);
  ND.N:=1;
  HS[0].NL:=1;
  HS[0].Expression:=Copy(SS,1,Length(SS));
 end;
end;

//find synt. error
if (NCop <> -1) and (BOP = 2) then
begin
 FindExternalBracket(HS[0].Expression,S1);
 FindExternalBracket(HS[1].Expression,S2);
 if (S1 = '') or (S2 = '') then
 begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=S;
 end;
end
else
if NCop <> -1 then
begin
   if HS[0].Expression = '' then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=S;
   end;
end;

endp:
end;




procedure TForevalD.SubstParam(S1: String;  var C: TFloat; var SB: Integer);
label endp;
var
N,i: Cardinal;
S1h,S3: String;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

C:=0;
if S1 = '' then
begin
F_SyntaxErrorCode:=5;
goto endp;
end;

N:=1; S1h:=Copy(S1,1,Length(S1));  SB:=0;


try
C:=StrToFloat({PointToDec(S1h)}S1h,G_FMT);
SB:=1;
except
SB:=0;
end;

endp:
end;




procedure TForevalD.NumberAnalizator(S: String;  var ND: TDataNode; var EOFN: Boolean);
label endp;
var
S2,S1,S3: String;
ni,SB,code: Integer;
C: TFloat;
TF: Integer;
BH: Boolean;
  I: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

EOFN:=False;
InitNode(ND);


FindControlCom(S,code,ni,BH);
if BH = True then
begin
 ND.COP:=code;
 ND.AI:=ni;
 EOFN:=True;
 goto endp;
end;

{
FindVar(S,ni);
 if ni >= 0 then
 begin
   ND.COP:=_LDSF;
   ND.NObj:=ni;
   EOFN:=True;
   //ND.TS:=TF;

   if FindDiffVar(ni) then
      ND.SDiff:='1' else
      ND.SDiff:='0';
   goto endp;
 end
 else
 SubstParam(S,C,SB);
 if SB = 1 then
 begin
  ND.FD:=C;
  ND.COP:=_LDSC;
  EOFN:=True;
  ND.SDiff:='0';
  goto endp;
 end
 else
 begin
   ND.COP:=_LDSF;
   ND.NObj:=0;
   EOFN:=True;
   ND.SDiff:='0';
 end;
 }

SubstParam(S,C,SB);
 if SB = 1 then
 begin
  ND.FD:=C;
  ND.COP:=_LDSC;
  EOFN:=True;
  ND.SDiff:='0';
  goto endp;
 end
 else
 begin
   ND.COP:=_LDSF;
   ND.NObj:=ni;
   EOFN:=True;
   S2:=Copy(S_DiffVar,1,Length(S_DiffVar));
   if F_VarShift = False then S2:=LowerCase(S2);
   S3:=S;
   if F_VarShift = False then S3:=LowerCase(S3);
   if S2 = S3 then  ND.SDiff:='1'
   else
   begin
    for I := 0 to Length(S3) do
    begin
      if (S3[i] = '[') or (S3[i] = ']') or (S3[i] = '(') or (S3[i] = ')') then
      begin
       F_SyntaxErrorCode:=1;
       F_SyntaxErrorString:=Copy(S,1,Length(S));
       EOFN:=False;
       goto endp;
      end;
    end;

    ND.SDiff:='0';
   end;

   goto endp;
 end;



{F_SyntaxErrorCode:=1;         // 
F_SyntaxErrorString:=Copy(S,1,Length(S));
EOFN:=False; }

endp:
end;




procedure TForevalD.FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
begin
FindJMP(S,ni);
 if ni <> 0 then
 begin
  code:=_JMP;
  BH:=True;
 end
else
begin
FindFLD(S,ni);
if ni <> 0 then
 begin
  code:=_FLD;
  BH:=True;
 end
end;

end;




procedure TForevalD.FindJMP(S: String; var ni: Integer);
begin
//ni= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

if S = '#JMP'    then ni:=1 else
if S = '#JMPE'   then ni:=2 else
if S = '#JMPEL'  then ni:=3 else
if S = '#JMPEB'  then ni:=4 else
if S = '#JMPB'   then ni:=5 else
if S = '#JMPL'   then ni:=6 else
if S = '#JMPNE'  then ni:=7 else
ni:=0;

end;



procedure TForevalD.FindFLD(S: String; var ni: Integer);
begin
//ni= 1     2
//  #FLD1, #FLDZ,
if S = '#FLD1'    then ni:=1 else
if S = '#FLDZ'   then ni:=2 else
ni:=0;
end;








procedure TForevalD.NumberAnalizatorA(S: String;  var nf: Integer; var FD: extended; var EF: Integer);
label endp;
var
S2: String;
ni,SB: Integer;
C: TFloat;
begin                   //EF = 1(number: FD); =2(var: nf); =0(other)
if F_SyntaxErrorCode <> 0 then goto endp;

nf:=-1;
FD:=0;
EF:=0;
FindVar(S,ni);
if ni >= 0 then
begin
 if (Alg.Obj[ni].TypeF = T_Real) or (Alg.Obj[ni].TypeF = T_Complex) then
 begin
  nf:=ni;
  EF:=_FVar;
 end;
end
else
begin
 SubstParam(S,C,SB);
 if SB = 1 then
 begin
 FD:=C;
 EF:=_Const;
 end;
end;

endp:
end;



procedure TForevalD.FindVar(S1: String; var ni: Integer);
label endp;
var
i: Cardinal;
S2,S3: String;
begin                                          //ni -    
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1: .  
ni:=-1;

S2:=Copy(S1,1,Length(S1));
if F_VarShift = False then S2:=LowerCase(S2);


for i:=0 to Length(Alg.Obj)-1 do
begin
S3:=Alg.Obj[i].Name;
if F_VarShift = False then S3:=LowerCase(S3);
 if S2 = S3 then
  begin
   if Alg.Obj[i].TypeF = T_Complex then F_ComplexNumber:=True;   //    
   ni:=i;
   goto endp;
  end;
end;



endp:
end;





function TForevalD.FindDiffVar(ni: Integer): Boolean;
var
S3,S2: String;
begin
S2:=Copy(S_DiffVar,1,Length(S_DiffVar));
if F_VarShift = False then S2:=LowerCase(S2);

S3:=Alg.Obj[ni].Name;

if F_VarShift = False then S3:=LowerCase(S3);

if S2 = S3 then FindDiffVar:=True else FindDiffVar:=False;
end;




procedure TForevalD.FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
label 1,endp;
var
bb,b2,b1,i: Integer;                                              //FH=True: func(arg)->Sf(Sa)
begin
                                                                   //BrS=(, [, {
FH:=False;
bb:=0; b1:=0;
for i:=1 to Length(S) do
begin
 if S[i] = {'('}BrS1 then begin b1:=i; goto 1; end;
end;
if b1 = 0 then begin FH:=False; goto endp; end;

1:
(*
b2:=0; bb:=-1;
for i:=b1+1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if S[i] = ')' then bb:=bb+1;
 if (i <> Length(S)) and (bb = 0) then begin {Internal Error} end;
end;
*)
if b1 = 1 then  FH:=False else FH:=True;
if S[Length(S)] <> BrS2 then   FH:=False;

Sf:=Copy(S,1,b1-1);
Sa:=Copy(S,b1+1,Length(S)-b1-1);

endp:
end;



procedure TForevalD.FindFunction(S: String;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
label 1,2,3,4,endp;
var
i,k,l,bb,pf,pr,b1,b2,nf,ni,TV: Integer;
S1,Sa,Sf,Sf1,Sfn,SFunc: String;
Neg,SB,TM: Integer;
ExFunc,FH,FH1: Boolean;
C: Extended;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
BH:=False;
EOFN:=False;
FH:=False;
FH1:=False;


//[-[x-1.5]-[-[x+5.7]]]-[t-[t-[t+7.5]-[t+1.8]]+t]

nf:=10000;
// [arg]->Trunc(arg); {arg}->Frac(arg)
if (S[1] = '[') and (S[Length(S)] = ']') and (F_SyntaxExtension = True) then begin SFunc:='trunc'; Sa:=Copy(S,2,Length(S)-2);goto 2; end
else
if (S[1] = '{') and (S[Length(S)] = '}') and (F_SyntaxExtension = True) then begin SFunc:='frac'; Sa:=Copy(S,2,Length(S)-2); goto 2; end
else
// : func(arg)
begin

  FindFuncBr(S,'(',')',Sf,Sa,FH);
  if FH = False then goto 3;



  if F_FuncShift = False then Sf1:=LowerCase(Sf) else Sf1:=Sf;

  //   -:  unknown(arg1,...,argn)->diff(unknown(arg1,...,argn),1)
  nf:=10000;
  //nf:=-1;






if F_FuncShift = False then Sf1:=LowerCase(Sf) else Sf1:=Sf;

if F_SyntaxExtension = True then
begin
for k:=0 to High(Alg.ExFunc) do
 begin
  for l:=0 to High(Alg.ExFunc[k].NameF) do
   begin
    Sfn:=Alg.ExFunc[k].NameF[l];
    if F_FuncShift = False then
    begin
     Sfn:=LowerCase(Sfn);
    end;
    if Sf1 = Sfn then  begin nf:=k;  SFunc:=Alg.ExFunc[k].Name; goto 2; end;
   end;
 end
end
else

 for i:=0 to High(Alg.ExFunc) do
  begin
    Sfn:=Alg.ExFunc[i].Name;
    if F_FuncShift = False then
    begin
     Sfn:=LowerCase(Sfn);
    end;
    if Sf1 = Sfn then  begin nf:=i; SFunc:=Alg.ExFunc[i].Name;  goto 2; end;
  end;

end;


2:
 if nf <> -1 then
 begin
    FindManyArg(Sa,ArgM);

    if Length(ArgM) = 0  then // INFINITE
    begin
     {-  }
     {F_SyntaxErrorCode:=4;
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));}

     //ForevalD:
      ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=0;  BH:=True; EOFN:=True; SetLength(LV,0);
     {-  }
     {F_SyntaxErrorCode:=4;
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf)); }
     goto endp;
    end;


    SetLength(LV,1);
    LV[0].Expression:=Copy(ArgM[0],1,Length(ArgM[0]));

    for i:= 1 to High(ArgM) do
    begin
     SetLength(LV,Length(LV)+1);
     LV[i].Expression:=Copy(ArgM[i],1,Length(ArgM[i]));

    end;

    ND.N:=Length(ArgM);
    ND.COP:=_Func;
    ND.NFunc:=nf;
    BH:=True;
    ND.SFunc:=SFunc;


    if LowerCase(Sfn) = 'if' then
    begin
     IFAnalizator(LV,ND,LV,ND);
     if F_SyntaxErrorCode <> 0 then F_SyntaxErrorString:=Copy(S,1,Length(S));
     BH:=True;
     EOFN:=False;
    end;

 end
 else  //nf=-1
 //  :AI = (1)Vec[num],(2)Vec[Trunc(Var)],(0)Vec[Trunc(Expr)]
 begin
  3:
  FindFuncBr(S,'[',']',Sf,Sa,FH1);
  //ForevalD:
  //if FH1 = True then FindVar(Sf,ni) else ni:=-1;
  if FH1 =  True then
  begin
   ND.COP:=_Func;
   ND.NFunc:=C_LDSVX;
   BH:=True;
   {SetLength(LV,1);
   LV[0].Expression:=Copy(Sa,1,Length(Sa));
   ND.N:=1;
   EOFN:=False; }
   EOFN:=True;
   ND.SDiff:='0';
   goto endp;
  end
  else
  begin
    BH:=False;
    goto endp;
  end;



 end;



endp:

end;






procedure TForevalD.FindManyArg(S: String; var ArgM: TArrayS);
label endp;
var
i,N,bb: Cardinal;
PP: array of Cardinal;
begin
if Length(S) = 0 then begin SetLength(ArgM,0); goto endp; end;

bb:=0;
N:=1; SetLength(PP,N+1); PP[1]:=0;

for i:=1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if (bb = 0) and (S[i] = ',') then begin inc(N); SetLength(PP,N+1); PP[N]:=i; end;
 if S[i] = ')' then bb:=bb+1;
end;

inc(N);  SetLength(PP,N+1); PP[N]:=Length(S)+1;

SetLength(ArgM,{N}N-1);

for i:=1 to N-1 do
begin
ArgM[{i}i-1]:=Copy(S,PP[i]+1,PP[i+1]-PP[i]-1);
if (ArgM[{i}i-1] = '')  then
begin
F_SyntaxErrorCode:=4; F_SyntaxErrorString:=Copy(S,1,Length(S)); goto endp;
end;
end;

endp:
end;





procedure   TForevalD.ReplaceTruncBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
//[-[x-1.5]-[-[x+5.7]]]-[t-[t-[t+7.5]-[t+1.8]]+t]
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '[' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = ']' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;





procedure   TForevalD.ReplaceFracBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '{' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = '}' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('frac(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;



procedure   TForevalD.ReplaceAbsBr(S: String; var S1: String);
label 1,endp;

             function GetTypeAbsBr(p: Integer; S: String): Integer;
             begin
              if p = 1 then GetTypeAbsBr:=1
              else
              if p = Length(S) then GetTypeAbsBr:=2
              else
              if (S[p-1] = '+') or (S[p-1] = '-') or (S[p-1] = '*') or
                 (S[p-1] = '/') or (S[p-1] = '^') or (S[p-1] = '(') or
                 (S[p-1] = '[') or (S[p-1] = '{') or (S[p-1] = ',') or
                 (S[p-1] = '=') or (S[p-1] = '<') or (S[p-1] = '>')
                 then GetTypeAbsBr:=1
              else
               GetTypeAbsBr:=2;
             end;


var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//||x-1|+|x+1||-|x-|x+|x-1|-|x+1||+y|
//||x-1|+||x+1|-|x+2|||-||x-1|+||x+1|^||x+2|-x|+|x+1||+|x+1||
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '|' then
   begin
     p:=i; goto 1;
   end;
  end;
  goto endp;
1:
  t:=GetTypeAbsBr(p,S);
  if t = 1 then
  begin
   Delete(S,p,1); Insert('abs(',S,p); p:=p+3
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;





procedure TForevalD.PrevTreat(S: String; var S1: String);
label endp;
var
b1,b2,i: Integer;
E: Exception;
begin
if S = '' then S:='0';
if F_SyntaxExtension = True then
begin
 ReplaceAbsBr(S,S);
 //ReplaceTruncBr(S,S);
 //ReplaceFracBr(S,S);
end;


F_SyntaxErrorCode:=0;
b1:=0; b2:=0;

for i:=1 to Length(S) do
begin
if S[i] = '(' then inc(b1);
if S[i] = ')' then inc(b2);
end;


if (b2-b1) > 0 then
begin
F_SyntaxErrorCode:=2;
F_SyntaxErrorString:=Copy(S,1,Length(S));
raise E.Create('');
end
else
if (b1-b2) > 0 then
begin
F_SyntaxErrorCode:=10;
F_SyntaxErrorString:=Copy(S,1,Length(S));
raise E.Create('');
end;

S1:=Copy(S,1,Length(S));
endp:
end;







procedure TForevalD.SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
label endp;
var
COP: String;
nf: Cardinal;
BH: Boolean;
a,b: TFloat;
Arg: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

EOFN:=False;
InitNode(ND);


StringAnalizator(Copy(S,1,Length(S)),ND,LV);
Arg:=Length(LV);
If ND.COP = 0 then
 begin
  FindFunction(LV[0].Expression,ND,LV,BH,EOFN);
  if BH = False then
  NumberAnalizator(LV[0].Expression,ND,EOFN);
 end;
 {else
 if (F_SaveInFPU = True) and (Arg = 2) and (F_OperationOptimizator = True )then OperationalAnalizator2(LV,ND,LV,ND,EOFN)
 else
 if (F_SaveInFPU = True) and (Arg = 1) and (F_OperationOptimizator = True ) then OperationalAnalizator1(LV,ND,LV,ND,EOFN); }



endp:
end;









procedure TForevalD.IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
label 1,endp;
var
C: TFloat;
br,cif,tif: Integer;
i,P,L: Integer;
nf: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
begin                                                                //tif: 7  4  3    2     5       6
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, ,<>, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)

//IF(Arg1 op Arg2)  = 1  0( if  )  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)

//IF(Arg1 op Arg2, Arg3)  = Arg3( if  )  0( if  )  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)


if F_SyntaxErrorCode <> 0 then goto endp;

LV1:=LV;
ND1:=ND;
L:=Length(LV);

if ((L <> 3) and (L <> 1) and (L <> 2)) then
begin
  F_SyntaxErrorCode:=4;
  goto endp;
end;

//nf= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

br:=0;  nf:=0;
Str:=LV[0].Expression;
FindExternalBracket(Str,Str);

for i := 1 to Length(Str) do
begin
 if (Str[i] = '(') or (Str[i] = '[') or (Str[i] = '{') then  br:=br+1 else
 if (Str[i] = ')') or (Str[i] = ']') or (Str[i] = '}') then  br:=br-1;

 if br = 0 then
 begin
   //>= , =>
   if ((Str[i] = '>') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '>')) then
   begin
     nf:=6;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<=, =<
   if ((Str[i] = '<') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '<')) then
   begin
     nf:=5; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<>
   if ((Str[i] = '<') and (Str[i+1] = '>')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   // =
   if (Str[i] = '=') then
   begin
     nf:=7;  P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // >
   if (Str[i] = '>') then
   begin
     nf:=3; P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // <
   if (Str[i] = '<') then
   begin
     nf:=4; P:=i;   Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
 end;
end;


1:
if nf = 0 then
begin
  F_SyntaxErrorCode:=5;
  goto endp;
end;

SetLength(LV1,6);


if L = 3 then    //IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#JMPE';
   3: LV1[2].Expression:='#JMPEL';
   4: LV1[2].Expression:='#JMPEB';
   5: LV1[2].Expression:='#JMPB';
   6: LV1[2].Expression:='#JMPL';
   7: LV1[2].Expression:='#JMPNE';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#JMP';
 LV1[5].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression));
 cif:=2;
end
else
if L = 1 then      //IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#JMPE';
   3: LV1[2].Expression:='#JMPEL';
   4: LV1[2].Expression:='#JMPEB';
   5: LV1[2].Expression:='#JMPB';
   6: LV1[2].Expression:='#JMPL';
   7: LV1[2].Expression:='#JMPNE';
 end;
 LV1[3].Expression:='#FLD1';
 LV1[4].Expression:='#JMP';
 LV1[5].Expression:='#FLDZ';
 cif:=0;
end
else
if L = 2 then      //IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)
begin
  LV1[0].Expression:=Copy(Str1,1,Length(Str1));
  LV1[1].Expression:=Copy(Str2,1,Length(Str2));
  case nf of
   2: LV1[2].Expression:='#JMPE';
   3: LV1[2].Expression:='#JMPEL';
   4: LV1[2].Expression:='#JMPEB';
   5: LV1[2].Expression:='#JMPB';
   6: LV1[2].Expression:='#JMPL';
   7: LV1[2].Expression:='#JMPNE';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#JMP';
 LV1[5].Expression:='#FLDZ';
 cif:=1;
end;


ND1.N:=6;
ND1.COP:=_FUNC;
ND1.NFunc:=C_IFNOP;
ND1.SFunc:='ifnop';
ND1.cif:=cif;
ND1.tif:=nf;

endp:
end;




procedure TForevalD.GetVar(N: Integer; var Adr: Cardinal; var TV: Integer; var TM: Integer);
begin
 {if (Alg.Obj[N].TypeF = T_Real) and (Alg.Obj[N].MType = _Double) then TV:=D_Real else
 if (Alg.Obj[N].TypeF = T_Real) and (Alg.Obj[N].MType = _Extended) then TV:=E_Real else
 if (Alg.Obj[N].TypeF = T_Complex) and (Alg.Obj[N].MType = _Double) then TV:=D_Complex else
 if (Alg.Obj[N].TypeF = T_Complex) and (Alg.Obj[N].MType = _Extended) then TV:=E_Complex;}

 TV:=Alg.Obj[N].TypeF;
 TM:=Alg.Obj[N].MType;
 if  LowerCase(Alg.Obj[N].Name) = S_IM_UNIT then TV:=IM_UNIT;
 Adr:=Alg.Obj[N].Addr;
end;







procedure TForevalD.InitNode(var ND: TDataNode);
var
i: Integer;
begin
ND.N:=0;
ND.NCOP:=0;
ND.NFunc:=0;
ND.NObj:=0;
ND.COP:=0;
ND.FD:=0;
ND.FX:=0;
ND.IdN:=0;
ND.NV1:=-1;
ND.NV2:=-1;
ND.TypeF:=0;
ND.Inv:=0;
ND.TS:=0;
ND.AI:=0;
ND.NF:=0;
ND.SDiff:='0';
end;






function TForevalD.PointToDec(S: String):String;
label
1;
var
i:Cardinal;
SS: String;
begin
SS:=Copy(S,1,Length(S));
for i:=1 to Length(S) do
 begin
  if SS[i] = '.' then
  begin
   Delete(SS,i,1);
   Insert(',',SS,i);
   goto 1;
 end
end;

1:
PointToDec:=Copy(SS,1,Length(SS));
end;




procedure TForevalD.CreateInitData;
begin                             //  


F_SyntaxErrorCode:=0;
LFunc:=0;

F_ShowException:=False;
F_ExternalException:=False;
F_VarShift:=False;
F_FuncShift:=False;
F_DataType:={_Extended;}_Double;
F_DinamicLoadOptimization:=True;
F_SaveInFPU:=True;
//F_SaveStack:=True;
F_StackDeep:=8;
F_Opt:=False;
F_SyntaxExtension:=True;
F_CalcType:=T_Complex;
F_OperationOptimizator:=True;


CreateFuncList;


//Application.OnException:=CalcException;

SetType(1);

REGA[1]:=0;
REGA[2]:=0;
REGA[3]:=0;
REGA[4]:=0;
REGA[5]:=0;
REGA[6]:=0;
REGA[7]:=0;
REGA[8]:=0;

NameTypeS[T_Real]:='Real';
NameTypeS[T_Complex]:='Complex';
NameTypeS[T_Array]:='Array';
NameTypeS[T_Integer]:='Integer';
end;





procedure TForevalD.SetExtExpression(S: String);
label endp;
var
I_LFunc: Cardinal;
E: Exception;
begin
InitConstDb;
try

F_SyntaxErrorCode:=0;
F_CalcErrorCode:=0;
F_InternalError:=0;
F_SyntaxErrorString:='';
F_ComplexNumber:=False;
F_IdN:=0;
CurrentExpression:=Copy(S,1,Length(S));
PrevTreat(S,S);
Linker(S);

SetDiff1;
S:=Tree^.SDiff;
S_DiffString:=S;

FreeTree;



except
 on E: EZeroDivide      do F_InternalError:=1;
 on E: EInvalidOp       do F_InternalError:=2;
 on E: EOverFlow        do F_InternalError:=3;
 on E: EUnderFlow       do F_InternalError:=4;
 on E: EIntOverFlow     do F_InternalError:=5;
 on E: EAccessViolation do F_InternalError:=6;
 on E: EOutOfMemory     do F_InternalError:=7;
 on E: EStackOverFlow   do F_InternalError:=8;
end;



if (F_InternalError <> 0 ) or (F_SyntaxErrorCode <> 0) then
begin
 CalcException;
end;
//BeginLinker:=1;
end;






constructor TForevalD.Create;
begin
//inherited Create(AOwner);
GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';
CreateInitData;
end;


destructor TForevalD.Destroy;
begin
Alg.Obj:=nil;
Alg.Opr:=nil;
Alg.ExFunc:=nil;
inherited Destroy;
end;



procedure TForevalD.FreeTree;
label endp;
var
H: PNode;
begin
//if F_SyntaxErrorCode <> 0 then goto endp;
Tree:=BeginTree;

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
  H:=Tree; Tree:=Tree^.Nb;  H^.Nb:=nil;
  H^.RData:=nil;
  dispose(H);
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP
 end;

//COP<>NOP
H:=Tree; Tree:=Tree^.Pr; H^.Pr:=nil;
H^.RData:=nil;
dispose(H);
end;
dispose(Tree);

endp:
end;



procedure TForevalD.RenameFunction(Name,NewName: String);
label endp;
var
i: Integer;
begin

  for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin
    Alg.ExFunc[i].Name:=Copy(NewName,1,Length(NewName));
    goto endp;
   end;
  end;

endp:
end;



procedure TForevalD.CalcException;
var
S: String;
T: Integer;
begin


if F_BeginCalc = 0 then
begin
 {on E: EZeroDivide      do F_InternalError:=1;
 on E: EInvalidOp       do F_InternalError:=2;
 on E: EOverFlow        do F_InternalError:=3;
 on E: EUnderFlow       do F_InternalError:=4;
 on E: EIntOverFlow     do F_InternalError:=5;
 on E: EAccessViolation do F_InternalError:=6;
 on E: EOutOfMemory     do F_InternalError:=7;
 on E: EStackOverFlow   do F_InternalError:=8;}
 {if E.ClassType  = EZeroDivide       then F_InternalError:=1
 else
 if E.ClassType =  EInvalidOp        then F_InternalError:=2
 else
 if E.ClassType =  EOverFlow         then F_InternalError:=3
 else
 if E.ClassType =  EUnderFlow        then F_InternalError:=4
 else
 if E.ClassType =  EIntOverFlow      then F_InternalError:=5
 else
 if E.ClassType =  EAccessViolation  then F_InternalError:=6
 else
 if E.ClassType =  EOutOfMemory      then F_InternalError:=7
 else
 if E.ClassType =  EStackOverFlow    then F_InternalError:=8;
 }
end

else
if F_SyntaxErrorCode = 0 then
begin
 {if E.ClassType  = EZeroDivide       then F_CalcErrorCode:=1
 else
 if E.ClassType =  EInvalidOp        then F_CalcErrorCode:=2
 else
 if E.ClassType =  EOverFlow         then F_CalcErrorCode:=3
 else
 if E.ClassType =  EUnderFlow        then F_CalcErrorCode:=4
 else
 if E.ClassType =  EIntOverFlow      then F_CalcErrorCode:=5
 else
 if E.ClassType =  EAccessViolation  then F_CalcErrorCode:=6;}

 F_BeginCalc:=0;
end;


if F_ShowException then
begin
 MessageBeep(MB_ICONHAND);
 if F_CalcErrorCode <> 0 then
 begin
  //MessageDlg('Calculation Error',mtError,[mbOk],0)
  MessageBox(0,PChar(S+#13+#10+'"'+'Calculation Error'+'"'),PChar('ForevalD error'),MB_ICONERROR);
 end
 else
 if F_SyntaxErrorCode <> 0 then
 begin
  if F_SyntaxErrorCode = 1  then S:='UNKNOWN SYMBOL:';
  if F_SyntaxErrorCode = 2  then S:='MISSING BRACKET "("';
  if F_SyntaxErrorCode = 3  then S:='MISSING OPERATION:';
  if F_SyntaxErrorCode = 4  then S:='INCOINCIDENCE NUMBER OF ARGUMENTS:';
  if F_SyntaxErrorCode = 5  then S:='MISSING EXPRESSION:';
  if F_SyntaxErrorCode = 6  then S:='UNKNOWN FUNCTION:';
  if F_SyntaxErrorCode = 7  then S:='ABSENT FUNCTION FOR LOAD TYPE:';
  if F_SyntaxErrorCode = 8  then S:='NOT DEFINED OPERATION '+'"'+F_SyntaxErrorString1+'"'+' FOR TYPES:';
  if F_SyntaxErrorCode = 9  then S:='NOT DEFINED FUNCTION '+'"'+F_SyntaxErrorString1+'"'+' FOR TYPES:';
  if F_SyntaxErrorCode = 10 then S:='MISSING BRACKET ")"';
  if F_SyntaxErrorCode = 11 then S:='ERROR AT ADDITION OF FUNCTION';

  //MessageDlg(S+#13+#10+'"'+F_SyntaxErrorString+'"',mtError,[mbOk],0)
  if F_ShowException = True  then

  MessageBox(0,PChar(S+#13+#10+'"'+F_SyntaxErrorString+'"'),PChar('ForevalD error'),MB_ICONERROR);
 end
 else
 if (F_InternalError <> 0) and (F_ShowException = True)  then
 //MessageDlg('Internal Error',mtError,[mbOk],0)
 MessageBox(0,PChar(S+#13+#10+'"'+'Internal Error'+'"'),PChar('ForevalD error'),MB_ICONERROR);
end;


if Assigned(ExtException) then ExtException;
end;







procedure TForevalD.SetDiff1;
label endp,pwr,extf;
var
N,NC,nn,tr,ng,ng1,ng2,ngd1,ngd2: Integer;
HTree,H1Tree: PNode;
S,SD,SD1,SD2,S1,S2,Sc,SE,SE1,SD1b,SD2b,S1b,S2b,SFunc,SX: String;
fx,fx1,fx2: extended;
bnum,bnum1,bnum2: boolean;
begin
F_ExtFuncD:=False;


if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; // , ..   - 


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP:
 inc(N);
end;

//COP<>NOP:
 //S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 S:=Tree^.Expression;
 S:='0';
 N:=1;
 NC:=Tree^.NCOP;
 HTree:=Tree^.Ch;
 SFunc:=Tree^.SFunc;



 if Tree^.COP = _Func then
 begin
   SD1:=HTree^.SDiff;
   S1:=HTree^.Expression;

   if {Alg.ExFunc[Tree^.NFunc].Name}SFunc = 'neg' then S:='('+SD1+')'  else
   begin

     tr:=0;

     if SFunc = 'sin'   then begin SD:='cos' ; tr:=1; end  else
     if SFunc = 'cos'   then begin SD:='-sin' ; tr:=1; end else
     if SFunc = 'exp'   then begin SD:='exp' ; tr:=1; end else
     if SFunc = 'ln'    then begin SD:='1/'  ; tr:=1; end else
     if SFunc = 'sqr'   then begin SD:='2*' ; tr:=1; end else
     if SFunc = 'sqrt'  then begin SD:='0.5/sqrt' ; tr:=1; end else
     if SFunc = 'sinh'  then begin SD:='cosh' ; tr:=1; end else
     if SFunc = 'cosh'  then begin SD:='sinh';  tr:=1; end;

     FindExternalBracketN(SD1,SD1b,ngd1);
     FindExternalBracketN(S1,S1b,ng1);

     if tr = 1 then
     begin
       if (SD1b = '1') and (ngd1 = 0) then S:=SD+'('+S1+')' else
         if (SD1b = '1') and (ngd1 = 1) then S:='-('+SD+'('+S1+'))' else
         if SD1b = '0' then  S:='0' else
         S:=SD+'('+S1+')*'+'('+SD1+')';

     end
     else
     if SFunc = 'tan' then
     begin
       //S:='(sqr(tan('+S1+'))+1)*'+SD1;
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/sqr(cos('+S1+'))';
     end
     else
     if SFunc = 'cotan' then
     begin
       //S:='(-(sqr(cotan('+S1+'))+1))*'+SD1;
       if SD1b = '0' then  S:='0' else
          S:='-('+SD1+')/sqr(sin('+S1+'))';
     end
     else
     if SFunc = 'arcsin' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/sqrt(1-sqr('+S1+'))';
     end
     else
     if SFunc = 'arccos' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='-('+SD1+')/sqrt(1-sqr('+S1+'))';
     end
     else
     if SFunc = 'arctan' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/(1+sqr('+S1+'))';
     end
     else
     if SFunc = 'arccotan' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='-('+SD1+')/(1+sqr('+S1+'))';
     end
     else
     if SFunc = 'tanh' then
     begin
       //S:='(sqr(tan('+S1+'))+1)*'+SD1;
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/sqr(cosh('+S1+'))';
     end
     else
     if SFunc = 'cotanh' then
     begin
       //S:='(-(sqr(cotan('+S1+'))+1))*'+SD1;
       if SD1b = '0' then  S:='0' else
          S:='-('+SD1+')/sqr(sinh('+S1+'))';
     end
     else
     if SFunc = 'arcsinh' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/sqrt(1+sqr('+S1+'))';
     end
     else
     if SFunc = 'arccosh' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/sqrt(sqr('+S1+')-1)';
     end
     else
     if SFunc = 'arctanh' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='-('+SD1+')/(sqr('+S1+')-1)';
     end
     else
     if SFunc = 'arccotanh' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='-('+SD1+')/(sqr('+S1+')-1)';
     end
     else
     if SFunc = 'log2' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/(('+S1+')*ln(2))';
     end
     else
     if SFunc = 'log10' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')/(('+S1+')*ln(10))';
     end
     else
     if  SFunc = 'abs' then
     begin
       if SD1b = '0' then  S:='0' else
          S:='('+SD1+')*sign('+S1+')'
     end
     else
     if  SFunc = 'fact' then
         S:='0'
     else
     if  SFunc = 'trunc' then
         S:='0'
     else
     if  SFunc = 'frac' then
         S:='0'
     else
     if  SFunc = 'sign' then
         S:='0'
     else
     if SFunc = 'log' then
     begin
       SD2:=HTree^.Nb^.SDiff;
       S2:=HTree^.Nb^.Expression;
       S:='('+SD2+')/(('+S2+')*ln('+S1+'))'+'-(('+SD1+')*'+'ln('+S2+'))/(('+S1+')*sqr(ln('+S1+')))';
     end
     else
     if SFunc = 'root' then
     begin
       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;
       FindExternalBracketN(SD2,SD2b,ng);

       if SD2b = '0' then S:='('+S1+')^(1/('+S2+')-1)'+'*('+SD1+')/('+S2+')' else
       if SD1b = '0' then  S:='-(('+S1+')^(1/('+S2+'))*('+SD2+')*'+'ln('+S1+')/sqr('+S2+'))' else

       S:='('+S1+')^(1/('+S2+')-1)'+'*('+SD1+')/('+S2+')-('+S1+')^(1/('+S2+'))*('+SD2+')*'+'ln('+S1+')/sqr('+S2+')';
     end
     else
     if (SFunc = 'max') or (SFunc = 'min') or (SFunc = 'sum') or (SFunc = 'avr') or
        (SFunc = 'sumq') or (SFunc = 'prod') or (SFunc = 'len') then
     begin
        if Tree^.Stack.N <= 1  then
        begin
          SD:=SD1;
        end
        else
        if (SFunc = 'max') or (SFunc = 'min') or (SFunc = 'sum') or (SFunc = 'avr') then
        begin
         H1Tree:=HTree;
         SD:=H1Tree^.SDiff;
         H1Tree:=H1Tree^.Nb;
         while H1Tree <> nil do
         begin
          SD:=SD+','+H1Tree^.SDiff;
          H1Tree:=H1Tree^.Nb;
         end;
        end
        else
        goto  extf;

         S:=SFunc+'('+SD+')';
     end
     else
     if SFunc = 'ifnop' then
     begin
      case Tree^.tif of
       7: Sc:='=';
       6: Sc:='>=';
       5: Sc:='=<';
       4: Sc:='<';
       3: Sc:='>';
       2: Sc:='<>';
      end;

       if Tree^.cif = 0 then  S:='0' else
       if Tree^.cif = 1 then
       begin
         S1:=HTree^.Expression;
         S2:=HTree^.Nb^.Expression;
         SD1:=HTree^.Nb^.Nb^.Nb^.SDiff;
         S:='if('+S1+Sc+S2+','+SD1+')';
       end
       else
       if Tree^.cif = 2 then
       begin
         S1:=HTree^.Expression;
         S2:=HTree^.Nb^.Expression;
         SD1:=HTree^.Nb^.Nb^.Nb^.SDiff;
         SD2:=HTree^.Nb^.Nb^.Nb^.Nb^.Nb^.SDiff;
         S:='if('+S1+Sc+S2+','+SD1+','+SD2+')';
       end;
     end
     else
     if SFunc = 'power' then  goto pwr
     else
     begin
     extf:       //external functions:
      {SE:=Tree^.Expression;
      FindExternalBracket(SE,SE);
      SE1:=Copy(SE,1,5);
      if SE1 = '@diff' then
       begin
        S:=HTree^.Expression;
        nn:=StrToInt(HTree^.Nb^.Expression);
        inc(nn);
        S:='@diff('+S+','+IntToStr(nn)+')';
       end
       else
       S:='@diff('+Tree^.Expression+',1)';}

       SE:=Tree^.Expression;
       FindExternalBracket(SE,SE);
       SE1:=Copy(SE,1,5);
       if SE1 = '@diff' then
       begin
         S:=HTree^.Expression;
         nn:=StrToInt(HTree^.Nb^.Expression);
         inc(nn);
         S:='@diff('+S+','+IntToStr(nn)+','+DiffVar+')';
       end
       else
       S:='@diff('+Tree^.Expression+',1,'+DiffVar+')';


       F_ExtFuncD:=True;

     end;


   end;
 end
 else
 if Tree^.COP = _COP then
 begin
   SD1:=HTree^.SDiff;           FindExternalBracketN(SD1,SD1b,ngd1);
   SD2:=HTree^.Nb^.SDiff;       FindExternalBracketN(SD2,SD2b,ngd2);
   S1:=HTree^.Expression;       FindExternalBracketN(S1,S1b,ng1);
   S2:=HTree^.Nb^.Expression;   FindExternalBracketN(S2,S2b,ng2);




   {+}
   if NC = 0 then
   begin
    if (SD1b = '0')  and  (SD2b = '0') then  S:='0' else
    if (SD1b <> '0') and  (SD2b <> '0') then   S:=SD1+'+'+'('+SD2+')' else
    if SD2b = '0'    then  S:=SD1 else
    if SD1b = '0'    then  S:=SD2;
   end
   else
   {-}
   if NC = 1 then
   begin
     {if SD2[1] = '-' then
     begin
      //Delete(SD2,1,1);
     end; }
     if (SD1b = '0') and (SD2b = '0') then  S:='0' else
     if (SD1b <> '0') and (SD2b <> '0') then  S:=SD1+'-'+'('+SD2+')' else
     if SD2b = '0' then   S:=SD1 else
     if SD1b = '0' then   S:='-'+SD2;

      //S:=S+'-'+'('+HTree^.SDiff+')'
   end
   else
   {*}
   if NC = 2 then
   begin
     if (SD1b = '0') and (SD2b = '0') then  S:='0'
        else
     if SD1b = '0'  then
     begin

        if (S1b = '0') or (SD2b = '0') then S:='0'
        else
          if (S1 = '1') and (ng1 = 0) then
           S:='('+SD2+')'
          else
          if (SD2b = '1') and (ngd2 = 0) then
           S:='('+S1+')'
          else

          if (S1 = '1') and (ng1 = 1) then
           S:='(-('+SD2+'))'
          else
          if (SD2b = '1') and (ngd2 = 1) then
           S:='(-('+S1+'))'
          else

           S:= '('+S1+')*('+SD2+')'
     end
     else
     if SD2b = '0'  then
     begin
        if (S2b = '0') or (SD1b = '0') then S:='0'
        else

         if (S2b = '1') and (ng2 = 0) then
          S:='('+SD1+')'
         else
          if (SD1b = '1') and  (ngd1 = 0) then
           S:='('+S2+')'
         else
         if (S2b = '1') and (ng2 = 1) then
          S:='(-('+SD1+'))'
         else
         if (SD1b = '1') and  (ngd1 = 1) then
           S:='(-('+S2+'))'
         else
           S:= '('+S2+')*('+SD1+')'
     end

     else
     if (SD1b = '1') and (ngd1 = 0)  then
      S:='('+S1+')'+'*'+'('+SD2+')'+'+('+S2+')'
      else
       if (SD2b = '1') and (ngd2 = 0) then
       S:='('+S1+')'+'+('+S2+')'+'*'+'('+SD1+')'
       else
       if (SD1 = '1') and (ngd1 = 1)  then
        S:='('+S1+')'+'*'+'('+SD2+')'+'-('+S2+')'
        else
        if (SD2b = '1') and (ngd2 = 1) then
        S:='('+S2+')'+'*'+'('+SD1+')'+'-('+S1+')'
        else
        S:='('+S1+')'+'*'+'('+SD2+')'+'+('+S2+')'+'*'+'('+SD1+')';
   end
   else
   {/}
   if NC = 3 then
   begin
     if (SD1b = '0') and (SD2b = '0') then  S:='0'
     else
     if SD1b = '0'  then
     begin
        if (S1b = '0') or (SD2b = '0') then S:='0'
        else
        S:='-('+SD2+')*('+S1+')/sqr('+S2+')'
     end
     else
     if SD2b = '0'  then
     begin
        if (S2b = '0') or (SD1b = '0') then S:='0'
        else
        S:='('+SD1+')*('+S2+')/sqr('+S2+')'
     end
     else
        S:='(('+SD1+')*('+S2+')-('+SD2+')*('+S1+'))/sqr('+S2+')';
   end
   else
   {power}
   if NC = 4 then
   begin
    pwr:

     SD1:=HTree^.SDiff;           FindExternalBracketN(SD1,SD1b,ng);
     SD2:=HTree^.Nb^.SDiff;       FindExternalBracketN(SD2,SD2b,ng);
     S1:=HTree^.Expression;       FindExternalBracketN(S1,S1b,ng);
     S2:=HTree^.Nb^.Expression;   FindExternalBracketN(S2,S2b,ng2);

     if SD2b = '0' then
     begin
       if (S2b = '0') or (SD1b = '0')  then  S:='0' else
       begin
        IsNum(S2,fx,bnum);
        if bnum = true then
        begin
          fx:=fx-1;
          if fx = 0 then S:='('+S2+')*('+SD1+')'
          else
          begin
            IsNum(S2,fx1,bnum1);
            IsNum(SD1,fx2,bnum2);
            if fx = 1  then SX:='' else SX:='^('+FloatToStr(fx,G_FMT)+')';

            if (bnum1 = true) and (bnum2 = true) then
             S:='('+S1+')'+SX{'^('+FloatToStr(fx)+')'}+'*('+FloatToStr(fx1*fx2,G_FMT)+')'
            else
            S:='('+S1+')'+SX{'^('+FloatToStr(fx)+')'}+'*('+S2+')*('+SD1+')'
          end;
        end
        else
        S:='('+S1+')^('+S2+'-1)'+'*('+S2+')*('+SD1+')'
       end;
     end
     else
     if SD1b = '0' then
     begin
      if SD2b = '0' then S:='0' else
      S:='('+S1+')^('+S2+')*('+SD2+')*'+'ln('+S1+')'
     end
     else
        S:='('+S1+')^('+S2+'-1)'+'*('+S2+')*('+SD1+')+('+S1+')^('+S2+')*('+SD2+')*'+'ln('+S1+')';
   end;

 end;





   HTree:=HTree^.Nb;
   while HTree <> nil do
   begin
    HTree:=HTree^.Nb;
   end;





 Tree^.SDiff:=S;

 NC:=Tree^.NCOP;
 if NC = 5 then S:='-('+S+')';

 Tree^.SDiff:='('+S+')';

end;


S:=Tree^.SDiff;

endp:
end;






 {
procedure TForevalD.InitFuncStruct(var FS: TIntFunc);
begin
  FS.TypeF:=0;
  FS.CallT:=0;
  FS.CLST:=0;
  FS.Arrow:=0;
  FS.Addr:=0;
  FS.N:=0;
  FS.SDeep:=-1;
  FS.IntF:=0;
  FS.TV:=nil;
  FS.TM:=nil;
end;
}



procedure TForevalD.CreateFuncList;
label endp;
var
TF,TM: TArrayC;
FS: TIntFunc;
begin
//INTERNAL (FS.IntF:=1)
//InitFuncStruct(FS);
FS.IntF:=1;
//   ///   !!!!!!!!!!!SEQUENCE NOT TO CHANGE
//{N} -    ()     Alg.ExFunc[N]
//REAL:
//func(arg1,arg2)
{FS.N:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real; }
//SetLoadFunction(T_Real,0,'Real');

{0}SetFunction('add');
{1}SetFunction('sub');
{2}SetFunction('mul');
{3}SetFunction('div');
{4}SetFunction('power');
{5}SetFunction('log');



//func(arg1)
{FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real; }
{6}SetFunction('neg');
{7}SetFunction('abs');
(*{8}SetFunction('re');
{9}SetFunction('im');
{10}SetFunction('arg');
*)

{11}SetFunction('sin');
{12}SetFunction('cos');
{13}SetFunction('tan');
{14}SetFunction('cotan');
{15}SetFunction('arccos');
{16}SetFunction('arcsin');
{17}SetFunction('arctan');
{18}SetFunction('arccotan');

{19}SetFunction('sinh');
{20}SetFunction('cosh');
{21}SetFunction('tanh');
{22}SetFunction('cotanh');
{23}SetFunction('arccosh');
{24}SetFunction('arcsinh');
{25}SetFunction('arctanh');
{26}SetFunction('arccotanh');


{27}SetFunction('ln');
{28}SetFunction('exp');
{29}SetFunction('sqr');
{30}SetFunction('sqrt');
{31}SetFunction('fact');
{32}SetFunction('log10');
{33}SetFunction('log2');

{34}SetFunction('root');
{35}SetFunction('trunc');
{36}SetFunction('frac');
{37}SetFunction('sign');
{38}SetFunction('max');
{39}SetFunction('min');
{40}SetFunction('if');
{41}SetFunction('ifnop');
{42}SetFunction('sum');
{43}SetFunction('sumq');
{44}SetFunction('prod');
{45}SetFunction('avr');





//     
//Addition of operations after addition of appropriate functions
//Operation:
SetOperation('+','add',1,0,0);
SetOperation('-','sub',1,0,0);
SetOperation('*','mul',2,0,0);
SetOperation('/','div',2,0,0);
SetOperation('^','power',3,0,1);
SetOperation('-','neg',1,-1,0);
SetOperation('!','fact',2,-2,1);


//ForevalD:
AddNewNameFunction('tan','tg');
AddNewNameFunction('cotan','ctg');
AddNewNameFunction('cotan','cot');
AddNewNameFunction('arcsin','asin');
AddNewNameFunction('arccos','acos');
AddNewNameFunction('arctan','atan');
AddNewNameFunction('arctan','arctg');
AddNewNameFunction('arccotan','arcctg');
AddNewNameFunction('arccotan','acot');
AddNewNameFunction('cotanh','cth');
AddNewNameFunction('cotanh','coth');
AddNewNameFunction('sinh','sh');
AddNewNameFunction('cosh','ch');
AddNewNameFunction('tanh','th');
AddNewNameFunction('arcsinh','arcsh');
AddNewNameFunction('arccosh','arcch');
AddNewNameFunction('arctanh','arcth');
AddNewNameFunction('arcsinh','asinh');
AddNewNameFunction('arccosh','acosh');
AddNewNameFunction('arctanh','atanh');
AddNewNameFunction('arccotanh','arccth');
AddNewNameFunction('arccotanh','acoth');

AddNewNameFunction('log10','lg');
AddNewNameFunction('log2','lg2');
AddNewNameFunction('sign','sgn');


//ForevalD:
//SetObject('@@@',Cardinal(@zi),T_Complex,_Double);
//SetDiffVar('x');



//   .   TAlgOperation
//For character change the description see of TAlgOperation

//endp:
end;






procedure TForevalD.InitConstDb;
begin
 Db_XchBrSDeep:=0;
 Db_XchBrNXch:=0;
 Db_DinLoadSDeep:=0;
 Db_DinLoadNMem:=0;
 Db_DinLoadOverFlow:=False;
 Db_CmplMaxStack:=0;
end;



end.
