unit LSE;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OpenML, HelpLSE;

type
  TFLSE = class(TForm)
    MA: TMemo;
    MR: TMemo;
    Label1: TLabel;
    RGM: TRadioGroup;
    RBG: TRadioButton;
    RBJ: TRadioButton;
    BS: TButton;
    BC: TButton;
    CBX: TCheckBox;
    CBY: TCheckBox;
    L1: TLabel;
    BH: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure MAKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MAMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BSClick(Sender: TObject);
    procedure RBGClick(Sender: TObject);
    procedure RBJClick(Sender: TObject);
    procedure ReadMx(var AX: TArray2; var BX: TArrayF;  var Er: Integer);
    procedure DeleteSpace(const S: String; var S1: String);
    procedure XchPoint(const S: String; var S1: String);
    procedure BHClick(Sender: TObject);
    procedure BCClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FLSE: TFLSE;
  A: TArray2;
  B,R: TArrayF;
  MathLib: TMathLib;
  HelpL: THelpL;
  G_FMT: TFormatSettings;

implementation
uses
UMHCFS;
{$R *.dfm}

procedure TFLSE.BCClick(Sender: TObject);
begin
ModalResult := mrCancel;
end;

procedure TFLSE.BHClick(Sender: TObject);
begin
 //H_Sett:=Sett;
 HelpL:=THelpL.Create(FLSE);
 HelpL.ShowModal;
 //HelpB.Init(Sett);
 //if SelMode.ShowModal = mrOk then

 //Sett:=H_Sett;
 HelpL.Destroy;
end;


procedure TFLSE.BSClick(Sender: TObject);
label endp;
var
N,i,j,Er,L: Integer;
F,D: TFloatType;
AX: TArray2;
BX: TArrayF;
begin
MR.Lines.Clear;
ReadMX(AX,BX,Er);
if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;

{
N:=Length(BX);
SetLength(A,N,N);
SetLength(B,N);

for I := 0 to N - 1 do
begin
  for J := 0 to N - 1 do
    begin
      A[i,j]:=AX[i,j];
    end;
  B[i]:=BX[i];
end;}
MathLib.LSE(AX,BX,R,D);
{
1     2      3      4
-2   3     -4      5
2   4     -1      3
}
{
1;     2;    -3;   4;     5;   -1;   = 1
-1;  -2;      2;   5;   -8;    5;    = -3
4;     3;      9;  -4;   -3;   -4;   = 4
7;    -5;    -9;  -2;     8;    7;   = 5
-8;    2;    -7;   5;     6;     2;  = 7
10;   1;     -1;  -6;    5;    -2;  =-9
}

{N:=6;
SetLength(A,N,N);
SetLength(B,N);


A[0,0]:=1; A[0,1]:=2; A[0,2]:=-3; A[0,3]:=4; A[0,4]:=5; A[0,5]:=-1;
A[1,0]:=-1; A[1,1]:=-2; A[1,2]:=2; A[1,3]:=5; A[1,4]:=-8; A[1,5]:=5;
A[2,0]:=4; A[2,1]:=3; A[2,2]:=9; A[2,3]:=-4; A[2,4]:=-3; A[2,5]:=-4;
A[3,0]:=7; A[3,1]:=-5; A[3,2]:=-9; A[3,3]:=-2; A[3,4]:=8; A[3,5]:=7;
A[4,0]:=-8; A[4,1]:=2; A[4,2]:=-7; A[4,3]:=5; A[4,4]:=6; A[4,5]:=2;
A[5,0]:=10; A[5,1]:=1; A[5,2]:=-1; A[5,3]:=-6; A[5,4]:=5; A[5,5]:=-2;
B[0]:=1; B[1]:=-3; B[2]:=4; B[3]:=5; B[4]:=7; B[5]:=-9;

MathLib.LSE(A,B,R);
}


for i:=0 to Length(R)-1 do
  begin
    MR.Lines.Add(FloatToStr(R[i],G_FMT))
  end;


{for i:=0 to Length(R)-1 do
  begin
    F:=R[i]*AX[0,i]+F;
  end; }

L1.Caption:=FloatToStr(D,G_FMT);


endp:
end;



procedure TFLSE.FormClose(Sender: TObject; var Action: TCloseAction);
var
L,i: Integer;
begin
L:=Length(R);
if L >= 1 then
begin
if  CBY.Checked then
begin
  for I := 0 to L - 1 do UMHCFS.Form1.R_Ys[i]:=R[i];

  UMHCFS.Form1.StSy.Caption:='Ys:'+IntToStr(L);
  UMHCFS.Form1.LeRSy:=L;
  UMHCFS.Form1.cRSy:=L-1;
  UMHCFS.Form1.CopyToRSyD;
end;
if  CBX.Checked then
begin
  for I := 0 to L - 1 do UMHCFS.Form1.R_Xs[i]:=R[i];
  UMHCFS.Form1.StS.Caption:='Xs:'+IntToStr(L);
  UMHCFS.Form1.LeRS:=L;
  UMHCFS.Form1.cRS:=L-1;
  UMHCFS.Form1.CopyToRSD;
end;
end;

end;

procedure TFLSE.FormCreate(Sender: TObject);
begin
 GetLocaleFormatSettings(0,G_FMT);
 G_FMT.DecimalSeparator:='.';

 MathLib.SetMode(ml_LSE_Method,ml_Gauss);
 MathLib.SetMode(ml_LSE_Method,ml_Jordan);
end;



procedure TFLSE.MAKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 //L1.Caption:=IntToStr(MA.CaretPos.Y);
end;



procedure TFLSE.MAMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 //L1.Caption:=IntToStr(MA.CaretPos.Y);
end;

procedure TFLSE.RBGClick(Sender: TObject);
begin
 MathLib.SetMode(ml_LSE_Method,ml_Gauss);
end;

procedure TFLSE.RBJClick(Sender: TObject);
begin
MathLib.SetMode(ml_LSE_Method,ml_Jordan);
end;




procedure TFLSE.ReadMx(var AX: TArray2; var BX: TArrayF;  var Er: Integer);
label endp;
label 1;
var
i,j,Str,Col,p: Integer;
SX: TArrayF;
F: TFloatType;
S,S1,S2: String;
BH: Boolean;
m: Integer;
begin
Str:=0; Col:=0; Er:=0;
for i := 0 to MA.Lines.Count do
begin
 p:=1;  SetLength(SX,0);
 for j := 1 to Length(MA.Lines[i]) do
 begin
   S1:=MA.Lines[i];
   BH:=True;
   if (MA.Lines[i][j] = ' ') or  (MA.Lines[i][j] = ';') or  (MA.Lines[i][j] = '=') or (j = Length(MA.Lines[i])) then
   begin
     S:=Copy(MA.Lines[i],p,j-p+1);
     DeleteSpace(S,S2);
     XchPoint(S2,S2);
     try
       F:=StrToFloat(S2,G_FMT);
     except
       BH:=False;
     end;
     if BH = True then
     begin
      p:=j;
      SetLength(SX,Length(SX)+1);
      SX[High(SX)]:=F;
     end;
   end;
 end;

 if Length(SX) <> 0  then
 begin
  SetLength(AX,i+1,Length(SX)-1);
  SetLength(BX,Length(BX)+1);
  BX[High(BX)]:=SX[High(SX)];
  for m := 0 to Length(SX) - 2 do
    begin
      AX[i,m]:=SX[m];
    end;
  if (i > 0) and (Length(SX) <> Col) then
  begin
    Er:=1;
    goto endp;
  end;
 end;

 Col:=Length(SX);

end;

if Length(AX) = 0 then  Er:=1 else
if Length(AX) <> Length(AX[0]) then  Er:=1 else
if Length(AX) <> Length(BX) then  Er:=1 else
if Length(AX[0]) = 0 then  Er:=1;

//////////
{for I := 0 to Length(SX) - 1 do
  begin
    MR.Lines[i]:=FloatToStr(SX[i]);
  end;
}
endp:
end;










procedure TFLSE.DeleteSpace(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = ' ') or  (S2[i] = ';') or (S2[i] = '=')then
   begin
    Delete(S2,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;





procedure TFLSE.XchPoint(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = ',') then
   begin
    Delete(S2,i,1);   Insert('.',S2,i);
   end;
   dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;



procedure TFLSE.Button1Click(Sender: TObject);
begin
 MA.PasteFromClipboard;
end;

end.
