unit data;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OpenML, HelpData, DefFN, Foreval_Lib;

  type
  TArraySt = array of String;
  type
  TArrayC = array of Cardinal;
type
  TFdata = class(TForm)
    MF: TMemo;
    MX: TMemo;
    Label1: TLabel;
    BS: TButton;
    BC: TButton;
    BH: TButton;
    MY: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    EA: TEdit;
    Label10: TLabel;
    EC: TEdit;
    Label11: TLabel;
    ED: TEdit;
    Label12: TLabel;
    EE: TEdit;
    Label13: TLabel;
    EF: TEdit;
    Label14: TLabel;
    EG: TEdit;
    Label8: TLabel;
    EB: TEdit;
    Label15: TLabel;
    L1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure MFMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BSClick(Sender: TObject);
    procedure RBGClick(Sender: TObject);
    procedure RBJClick(Sender: TObject);

    procedure DeleteSpace(const S: String; var S1: String);
    procedure XchPoint(const S: String; var S1: String);
    procedure BHClick(Sender: TObject);
    procedure BCClick(Sender: TObject);
    procedure MXMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MYMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MFKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MXKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MYKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function  GetFuncName(SF,SFM: String; MX: TArraySt): String;
    procedure CompilePC;
    procedure ConvertFuncName(S: String;  var FN: String; var LVT: TArrayC; var VN,VT,RT: Integer);
    procedure FindFuncArg(SA: String; var MX: TArraySt; var VT: Integer);

  end;

var
  Fdata: TFdata;
  A: TArray2;
  B,R: TArrayF;
  MathLib: TMathLib;
  HelpD: THelpD;
  FDFN: TFuncPC;
  PCnt: Integer;
  G_FMT: TFormatSettings;

implementation
uses
UMHCFS;

{$R *.dfm}



procedure TFdata.CompilePC;
label 1,2;
var
i,j,L: Integer;
FS: TAddFuncStruct;
S,FN: String;
LVT: TArrayC;
VN,VT,RT: Integer;
IDF,Er: Cardinal;
begin


L:=Length(UMHCFS.Form1.PC_S);

  for i:=0 to {FDFN.MA.Lines.Capacity}L-1 do
  begin

    InitFuncStruct(FS);
    FS.CallType:=fl_PRECOMPILED;

    //S:=FDFN.MA.Lines[i];
    S:=UMHCFS.Form1.PC_S[i];
    PCnt:=i;

    DeleteSpace(S,S);
    if S = '' then goto 1;


    ConvertFuncName(S,FN,LVT,VN,VT,RT);
    if VT = 0 then
    begin
       for j := 0 to  High(LVT) do
       begin
         case LVT[j] of
           1:  LVT[j]:=fl_double;
           2:  LVT[j]:=fl_integer;
           //3:  LVT[j]:=fz_complex_double;
           4:  LVT[j]:=fl_array_extended;
           5:  LVT[j]:=fl_extended;
         end;
       end;
       FS.ArgType:=fl_differ;
       FS.ArgTypeList:=@LVT[0];
    end
    else
    begin
      case VT of
        1:  FS.ArgType:=fl_double;
        2:  FS.ArgType:=fl_integer;
        //3:  FS.ArgType:=fz_complex_double;
        4:  FS.ArgType:=fl_array_extended;
        5:  FS.ArgType:=fl_extended;
      end;
    end;

    {case RT of
      0:   FS.ResultType:=fz_real;
      1:   FS.ResultType:=fz_real;
      3:   FS.ResultType:=fz_complex;
    end;}

    if FN <> '' then
    begin
      flSetFunction(FN,@FS,IDF);
      flGetErrorCode(Er);
      if Er <> 0  then
      begin
       MessageBox(0,PChar('Syntax error'+#13+#10+'"'+S+'"'),PChar('Foreval error'),MB_ICONERROR);
      end;
    end
    else
    MessageBox(0,PChar('Syntax error'+#13+#10+'"'+S+'"'),PChar('Foreval error'),MB_ICONERROR);

    LVT:=nil;

    1:
  end;

end;








procedure TFdata.ConvertFuncName(S: String;  var FN: String; var LVT: TArrayC; var VN,VT,RT: Integer);
label 1,endp;
var                                                               //TV[i]=_float,_integer,_complex,_array
SF,SA,S1,S2,S3,S4,SFM,SR: String;
MA,MAN,MX,MX1: TArraySt;
br1,br2,i,L,p,L1,j: Integer;
BT: Boolean;
begin
//DeleteSpace(S,S);
FN:='';
P:=Pos('=',S);
S1:=Copy(S,1,P-1);
SFM:=Copy(S,P,Length(S)-P+1); //+ '='
RT:=0;
P:=Pos(')',S1);

if S1 = '' then  begin UMHCFS.Form1.PC_S[PCnt]:='';  goto endp; end;

if S1[p+1] = ':' then
begin
  SR:=Copy(S1,p+2,Length(S1)-p-1);
  if SR = 'real'    then RT:=1 else
  if SR = 'float'   then RT:=1 else
  if SR = 'complex' then RT:=3;
end;


L:=Length(S1);
br1:=0; br2:=0;
for i := 1 to L do
begin
  if (S1[i] = '(') and (br1 = 0) then begin SF:=Copy(S1,1,i-1); br1:=i; end;
  if (S1[i] = ')') and (br2 = 0) then begin  br2:=i; SA:=Copy(S1,br1+1,br2-br1-1);  goto 1; end;
end;

1:
p:=1;
for i := 1 to Length(SA) do
begin
  if SA[i] = ';' then
  begin
   SetLength(MA,Length(MA)+1);
   MA[High(MA)]:=Copy(SA,p,i-p);
   p:=i+1;
  end;
end;
if p > 1 then
begin
 SetLength(MA,Length(MA)+1);
 MA[High(MA)]:=Copy(SA,p,Length(SA)-p+1);
end;
if Length(MA) = 0 then
begin

//func(x1,..,xn: type)
//func(x1,..xn)
//func(x1)
//func(x1: type)
FindFuncArg(SA,MX,VT);
VN:=Length(MX);
FN:=GetFuncName(SF,SFM,MX);

end
else
//func(x1,..,xn: type1; y1,..,yn: type2,..)
begin
 for i := 0 to High(MA) do
 begin
   FindFuncArg(MA[i],MX,VT);
   L:=Length(MX);
   L1:=Length(MX1);
   SetLength(MX1,Length(MX1)+L);
   SetLength(LVT,Length(LVT)+L);
   for j := 0 to L-1 do
   begin
    MX1[L1+j]:=MX[j];
    LVT[L1+j]:=VT;
   end;
   MX:=nil;
 end;

 VN:=Length(MX1);
 FN:=GetFuncName(SF,SFM,MX1);

 VT:=LVT[0];
 BT:=True;
 for I := 1 to High(LVT) do
 begin
    if VT <> LVT[i] then BT:=False;
 end;

 if BT = True  then
 begin
   LVT:=nil;
 end
 else
 VT:=0;

end;

endp:
end;



function TFdata.GetFuncName(SF,SFM: String; MX: TArraySt): String;
var
S: String;
i: Integer;
begin
S:='';
if Length(MX) = 1 then S:=MX[0]
else
begin
  for i := 0 to High(MX) - 1 do
  begin
   S:=S+MX[i]+',';
  end;
  S:=S+MX[High(MX)];
end;

GetFuncName:=SF+'('+S+')'+SFM;

end;


procedure TFdata.FindFuncArg(SA: String; var MX: TArraySt; var VT: Integer);
var
 i,p: Integer;
 S2,S3: String;
begin
//x1,..,xn: type
//x1,..xn
//x1
//x1: type
VT:=0;
 P:=Pos(':',SA);
 if P <> 0 then
 begin
  S2:=Copy(SA,1,P-1);  //x1,..xn
  S3:=LowerCase(Copy(SA,P+1,Length(SA)-P+1)); //type
  if S3 = 'float'     then VT:=1 else
  if S3 = 'real'      then VT:=1 else
  if S3 = 'integer'   then VT:=2 else
  if S3 = 'complex'   then VT:=3 else
  if S3 = 'array'     then VT:=4 else
  if S3 = 'double'    then VT:=1 else
  if S3 = 'extended'  then VT:=5;

 end
 else
 begin
   VT:=1;
   S2:=SA;
 end;
p:=1;
 for i:=1 to Length(S2) - 1 do
 begin
     if S2[i] = ',' then
     begin
      SetLength(MX,Length(MX)+1);
      MX[High(MX)]:=Copy(S2,p,i-p);
      p:=i+1;
     end;
 end;
 if p <> 1 then
 begin
   SetLength(MX,Length(MX)+1);
   MX[High(MX)]:=Copy(S2,p,Length(S2)-p+1);
 end;

 if Length(MX) = 0 then
 begin
   SetLength(MX,1);
   MX[0]:=Copy(S2,1,Length(S2));
 end;

end;







procedure TFdata.BCClick(Sender: TObject);
begin
 ModalResult := mrCancel;
end;

procedure TFdata.BHClick(Sender: TObject);
begin
 HelpD:=THelpD.Create(Fdata);
 HelpD.ShowModal;
 HelpD.Destroy;
end;

procedure TFdata.BSClick(Sender: TObject);
label endp;
var
N,i,j,Er,L: Integer;
S: String;
F: TFloatType;
BH: Boolean;
begin

{
if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;
}

/////FS//////////
 N:=MF.Lines.Count; L:=0;
 for i:=0 to N-1 do
 begin
   BH:=False;
   S:=MF.Lines[i];
   DeleteSpace(S,S);
   if S <> '' then
    begin
    if BH = False then begin UMHCFS.Form1.F_S[L]:=S;  inc(L); end;
   end;
 end;
 if L >=1 then
 begin
   UMHCFS.Form1.LeFS:=L;
   UMHCFS.Form1.cFS:=L-1;
   UMHCFS.Form1.StFS.Caption:='F'+IntToStr(L);
   UMHCFS.Form1.SFunc:=UMHCFS.Form1.F_S[0];
   UMHCFS.Form1.StFx.Caption:='f(x)';
   UMHCFS.Form1.LF.Caption:=Copy(UMHCFS.Form1.SFunc,1,Length(UMHCFS.Form1.SFunc));
   UMHCFS.Form1.cFP:=Length(UMHCFS.Form1.SFunc);
   UMHCFS.Form1.SetFunctionA;
 end
 else
 begin
  UMHCFS.Form1.LeFS:=0;
  UMHCFS.Form1.cFS:=-1;
  UMHCFS.Form1.SFunc:='';
  UMHCFS.Form1.StFx.Caption:='';
  UMHCFS.Form1.LF.Caption:='';
  UMHCFS.Form1.StFS.Caption:='  ';
 end;
//////////////Xs//////////
 N:=MX.Lines.Count; L:=0;
 for i:=0 to N-1 do
 begin
   BH:=False;
   S:=MX.Lines[i];
   DeleteSpace(S,S);
   XchPoint(S,S);
   if S <> '' then
    begin
    try
      F:=StrToFloat(S,G_FMT);
    except
      MessageBeep(MB_ICONHAND);
      MessageDlg('Not a number:'+'Xs['+IntToStr(i)+']:'+'    '+S,mtError,[mbOk],0);
      BH:=True;
    end;
    if BH = False then begin UMHCFS.Form1.R_Xs[L]:=F;  inc(L); end;
   end;
 end;
 if L >=1 then
 begin
   UMHCFS.Form1.LeRS:=L;
   UMHCFS.Form1.cRS:=L-1;
   UMHCFS.Form1.StS.Caption:='Xs:'+IntToStr(L)
 end
 else
 begin
  UMHCFS.Form1.LeRS:=0;
  UMHCFS.Form1.cRS:=-1;
  UMHCFS.Form1.StS.Caption:='  ';
 end;
 UMHCFS.Form1.CopyToRSD;

///////////Ys//////////
 N:=MY.Lines.Count; L:=0;
 for i:=0 to N-1 do
 begin
   BH:=False;
   S:=MY.Lines[i];
   DeleteSpace(S,S);
   XchPoint(S,S);
   if S <> '' then
    begin
    try
      F:=StrToFloat(S,G_FMT);
    except
      MessageBeep(MB_ICONHAND);
      MessageDlg('Not a number:'+'Ys['+IntToStr(i)+']:'+'    '+S,mtError,[mbOk],0);
      BH:=True;
    end;
    if BH = False then begin UMHCFS.Form1.R_Ys[L]:=F;  inc(L); end;
   end;
 end;
 if L >=1 then
 begin
   UMHCFS.Form1.LeRSy:=L;
   UMHCFS.Form1.cRSy:=L-1;
   UMHCFS.Form1.StSy.Caption:='Ys:'+IntToStr(L)
 end
 else
 begin
  UMHCFS.Form1.LeRSy:=0;
  UMHCFS.Form1.cRSy:=-1;
  UMHCFS.Form1.StSy.Caption:='  ';
 end;
 UMHCFS.Form1.CopyToRSyD;



//////////registers////////////
try
 DeleteSpace(EA.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_A:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number a:   '+S,mtError,[mbOk],0);
end;

try
 DeleteSpace(EB.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_B:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number b:   '+S,mtError,[mbOk],0);
end;

try
 DeleteSpace(EC.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_C:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number c:   '+S,mtError,[mbOk],0);
end;

try
 DeleteSpace(ED.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_D:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number d:   '+S,mtError,[mbOk],0);
end;

try
 DeleteSpace(EE.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_E:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number e:   '+S,mtError,[mbOk],0);
end;

try
 DeleteSpace(EF.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_F:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number f:   '+S,mtError,[mbOk],0);
end;

try
 DeleteSpace(EG.Text,S);
 XchPoint(S,S);
 UMHCFS.Form1.F_G:=StrToFloat(S,G_FMT);
except
 MessageBeep(MB_ICONHAND);
 MessageDlg('Not a number g:   '+S,mtError,[mbOk],0);
end;


endp:
end;



procedure TFdata.FormCreate(Sender: TObject);
var
i,L: Integer;
begin
GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';

 MF.Lines.Clear;
 MX.Lines.Clear;
 MY.Lines.Clear;

 L:=UMHCFS.Form1.LeRS;
 for i:=0 to L-1 do
 begin
   MX.Lines.Add(FloatToStr(UMHCFS.Form1.R_Xs[i],G_FMT))
 end;

 L:=UMHCFS.Form1.LeRSy;
 for i:=0 to L-1 do
 begin
   MY.Lines.Add(FloatToStr(UMHCFS.Form1.R_Ys[i],G_FMT))
 end;

 L:=UMHCFS.Form1.LeFS;
 for i:=0 to L-1 do
 begin
   MF.Lines.Add(UMHCFS.Form1.F_S[i])
 end;

 EA.Text:=FloatToStr(UMHCFS.Form1.F_A,G_FMT);
 EB.Text:=FloatToStr(UMHCFS.Form1.F_B,G_FMT);
 EC.Text:=FloatToStr(UMHCFS.Form1.F_C,G_FMT);
 ED.Text:=FloatToStr(UMHCFS.Form1.F_D,G_FMT);
 EE.Text:=FloatToStr(UMHCFS.Form1.F_E,G_FMT);
 EF.Text:=FloatToStr(UMHCFS.Form1.F_F,G_FMT);
 EG.Text:=FloatToStr(UMHCFS.Form1.F_G,G_FMT);


 L1.Caption:='F['+IntToStr(L)+']';
end;



procedure TFdata.MFKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
L1.Caption:='F['+IntToStr(MF.CaretPos.Y)+']';
end;

procedure TFdata.MFMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 L1.Caption:='F['+IntToStr(MF.CaretPos.Y)+']';
end;

procedure TFdata.MXKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
Label3.Caption:='Xs['+IntToStr(MX.CaretPos.Y)+']';
end;

procedure TFdata.MXMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Label3.Caption:='Xs['+IntToStr(MX.CaretPos.Y)+']';
end;

procedure TFdata.MYKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
Label4.Caption:='Ys['+IntToStr(MY.CaretPos.Y)+']';
end;

procedure TFdata.MYMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Label4.Caption:='Ys['+IntToStr(MY.CaretPos.Y)+']';
end;

procedure TFdata.RBGClick(Sender: TObject);
begin
 MathLib.SetMode(ml_LSE_Method,ml_Gauss);
end;

procedure TFdata.RBJClick(Sender: TObject);
begin
 MathLib.SetMode(ml_LSE_Method,ml_Jordan);
end;










procedure TFdata.DeleteSpace(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = ' ') then
   begin
    Delete(S2,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;





procedure TFdata.XchPoint(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = ',') then
   begin
    Delete(S2,i,1);   Insert('.',S2,i);
   end;
   dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;



procedure TFdata.Button1Click(Sender: TObject);
begin
 FDFN:=TFuncPC.Create(Form1);
 FDFN.ShowModal;
 FDFN.Destroy;
end;



end.
